implementation class
FileChild : GnomeMDIChild

end;

implementation instance
FileChild
{
  String filename;
  GnomeUIArray childmenu;
  public mutable GnomeMDI mdi;
  MutableObjectArray linkitems;
}

private void 
  setViews String value
{
  ObjectArray views = [self views];
  int i, n = [views length];
  for (i=0; i<n; i++) {
    GtkText t=[views[i] get_data "textobject"];
    [t insert (nil, nil, nil, value)];
  }
}

boolean
  load_from_file String fn
{
  File f = [File open fn input: YES];
  if (f) {
    filename = fn;
    [self set_name [File basename filename]];
    MutableByteString value = [MutableByteString new];
    File infile = [File open filename input: YES];
    [self setViews [infile contents]];
  } else {
    return FALSE;
  }
} 

id
  init pointer p
{
  = [super init p];
  [self set_name "*file buffer*"];
  [self connect "create_view" to self using selector (GtkWidget create_view)];
  linkitems = [MutableObjectArray new];
  childmenu =
    [GnomeUIArray with ([GnomeUIInfoSubtree 
			  new "Child"
			  subtree [GnomeUIArray 
				    with ([GnomeUIInfoItem new "Add View"
							   to [Invocation
								for selector (void add_view)
								to: self]
							   tip: "Add view to active Child."],
					  [GnomeUIInfoItem new "Remove View"
							   to [Invocation
								for selector (void remove_view)
								to: self]
							   tip: "Remove active View."])]])];
  [self set_menu_template childmenu];
}

void
  add_view
{
  /* WE are the correct MDIChild, as there are no MyChilds created for new views.
   */
  [mdi add_view self];
}

void
  remove_view
{
  if ([mdi active_view] != nil)
    [mdi remove_view ([mdi active_view], FALSE)];
}

GtkWidget (res)
  create_view
{
  GtkHBox hbox = [GtkHBox new (FALSE, 0)];
  [hbox show];
  
  GtkText t = [GtkText new (nil, nil)];
  [t set_editable TRUE];
  [t set_word_wrap FALSE];
  [t show];
  [hbox pack_start (t, TRUE, TRUE, 0)];
  GtkVScrollbar sbar = [GtkVScrollbar new [t vadj]];
  [sbar show];
  [hbox pack_start (sbar, FALSE, FALSE, 0)];

  GtkObjectLinkedItem textptr = [[GtkObjectLinkedItem alloc] initForObject hbox 
							     key "textobject"
							     LinkedItem t];
  [linkitems add textptr];
  
  = hbox;
}

end;
