implementation class
MDIEditApp : State, tomgnome.Constants

int
  main MutableArray arguments
{
  = [[self alloc] init arguments];
}

end;

implementation instance
MDIEditApp
{
  GnomeMDI mdi;
}

int
  init MutableArray arguments
{
  [Gnome init "mdiedit" args arguments];
  GnomeUIArray filemenu =
    [GnomeUIArray with ([GnomeUIInfoItem new "New File"
					 to [Invocation
					      for selector (void new_file)
					      to: self]
					 tip: "Create a new file buffer."],
			[GnomeUIInfoItem new "Open File..."
					 to [Invocation
					      for selector (void process_file_open)
					      to: self]
					 tip: "Create a new file buffer."],
			[GnomeUIInfoSeparator new],
			[GnomeUIInfoItem new "Add Child"
 					 to [Invocation
					      for selector (void add_cb)
					      to: self]
					 tip: "Add Child."],
			[GnomeUIInfoItem new "Remove Child"
					 to [Invocation
					      for selector (void remove_cb)
					      to: self]
					 tip: "Remove active Child."],
			[GnomeUIInfoSeparator new],
			[GnomeUIInfoItem new "Quit"
					 to [Invocation
					      for selector (void destroy)
					      to: self]
					 tip: "Quit this cool and innovative program."
					 stock: "Menu_Quit"])];

  GnomeUIArray modemenu = 
    [GnomeUIArray with ([GnomeUIInfoItem new "Notebook"
 					 to [Invocation
					      for selector (void set_mdi_mode int)
					      to: self
					      with GNOME_MDI_NOTEBOOK]
					 tip: "Notebook mode."],
			[GnomeUIInfoItem new "Toplevel"
					 to [Invocation
					      for selector (void set_mdi_mode int)
					      to: self
					      with GNOME_MDI_TOPLEVEL]
					 tip: "Toplevel mode."],
			[GnomeUIInfoItem new "Modal"
					 to [Invocation
					      for selector (void set_mdi_mode int)
					      to: self
					      with GNOME_MDI_MODAL]
					 tip: "Modal mode."])];

  GnomeUIArray helpmenu = 
    [GnomeUIArray 
      with ([GnomeUIInfoItem new "About"
			     to [Invocation 
				  for selector (void about)
				  to: self]
			     tip: "Click here for more info"
			     stock: "Menu_About"])];

  GnomeUIArray mainmenu = 
    [GnomeUIArray 
      with ([GnomeUIInfoSubtree new "File"
				subtree filemenu],
	    [GnomeUIInfoSubtree new "Children"
				subtree [GnomeUIArray with ([GnomeUIInfoEnd new])]],
	    [GnomeUIInfoSubtree new "MDI Mode"
				subtree modemenu],
	    [GnomeUIInfoSubtree new "Help"
				subtree helpmenu])];
  mdi = [GnomeMDI new ("mdiedit","mdiedit title?")];
  [mdi set_menu_template mainmenu];
  [mdi set_child_menu_path "File"];
  [mdi set_child_list_path "Children/"];
  [mdi set_mode GNOME_MDI_NOTEBOOK];
  [mdi connect "destroy" 
       to self
       using selector (void destroy)
       after: NO];

  [gtomk main];  
}

void
  process_file_open 
{
  Invocation invoke = [Invocation for selector(void openfile String) 
				  to: self]; 

  [[[FileSelectionController alloc] 
     initOk invoke]
    run];
}

void
  openfile String r
{
  [[[stdio err] print ("open ",r)] nl];
  FileChild mc = [FileChild new];
  [mc set_mdi mdi];
  [mdi add_child mc];
  [mdi add_view mc];
  [mc load_from_file r];
  //  [self set_mdi_mode GNOME_MDI_TOPLEVEL];
  //  [self set_mdi_mode GNOME_MDI_NOTEBOOK];
  [self set_mdi_mode -1];
}

void
  set_mdi_mode int mode
{
  [mdi set_mode mode];
}

void
  new_file
{
  FileChild mc = [FileChild new];
  [mc set_mdi mdi];
  [mdi add_child mc];
  [mdi add_view mc];
}

void
  add_cb
{
  MyChild mc = [MyChild new];
  [mc set_mdi mdi];
  [mdi add_child mc];
  [mdi add_view mc];
}

void
  remove_cb
{
  MyChild mc = MyChild([[mdi active_view] gnome_mdi_view_get_child]);
  [mdi remove_child (mc, FALSE)];
}

void
  destroy
{
  [gtomk main_quit];
}

void
  about
{
  [[GnomeAbout new "mdiedit"
	       version "0.0"
	       copyright "anonymous"
	       authors [ObjectArray with ("anonymous")]
	       comments "coll and innovative. (spelling innovative)"
	       logo nil] show];
}

end;

implementation class
MyChild : GnomeMDIChild
{
  int counter;
}

end;

implementation instance
MyChild 
{
  int mycounter;
  GnomeUIArray childmenu;
  public mutable GnomeMDI mdi;
}

id
  init pointer p
{
  = [super init p];
  mycounter = counter++;
  MutableByteString help = [MutableByteString new];
  [help print ("Child ", mycounter)];
  [self set_name help];
  [self connect "create_view" to self using selector (GtkWidget create_view)];
  childmenu =
    [GnomeUIArray with ([GnomeUIInfoSubtree 
			  new "Child"
			  subtree [GnomeUIArray 
				    with ([GnomeUIInfoItem new "Add View"
							   to [Invocation
								for selector (void add_view)
								to: self]
							   tip: "Add view to active Child."],
					  [GnomeUIInfoItem new "Remove View"
							   to [Invocation
								for selector (void remove_view)
								to: self]
							   tip: "Remove active View."])]])];
  [self set_menu_template childmenu];
}

void
  add_view
{
  /* WE are the correct MDIChild, as there are no MyChilds created for new views.
   */
  [mdi add_view self];
}

void
  remove_view
{
  if ([mdi active_view] != nil)
    [mdi remove_view ([mdi active_view], FALSE)];
}

GtkWidget
  create_view
{
  MutableByteString help = [MutableByteString new];
  [help print ("Child ", mycounter)];
  = [GtkLabel new help];
}

end;

