<copyright> gtomk packbox example.
    A rewrite in TOM of the original packbox.c example,
    as it appears in the gtk+ tutorial.
    By <a href="mailto:yacc@gerbil.org">Andreas Kostyrka</a>

    Copyright &copy; 1998 Andreas Kostyrka.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: PackBox.t,v 1.3 1999/04/17 08:11:11 tiggr Exp $</id>
    </copyright>

implementation class
PackBox: Constants

void
  destroy
{
  [gtomk main_quit];
}

boolean
  delete_event pointer event
{
  [gtomk main_quit];
}

int
  main MutableArray args
{
  [gtomk init args];

  /* Create our window */
  GtkWindow window = [GtkWindow new GTK_WINDOW_TOPLEVEL];
  /* You should always remember to connect the destroy signal to the
   * main window.  This is very important for proper intuitive
   * behavior */
  [window connect "delete_event" to self using selector (boolean delete_event pointer)];
  [window connect "destroy" to self using selector (void destroy) after: NO];

  /* We create a vertical box (vbox) to pack the horizontal boxes into.
   * This allows us to stack the horizontal boxes filled with buttons one
   * on top of the other in this vbox. */

  GtkVBox box1 = [GtkVBox new (FALSE, 0)];

  if ([args length] == 1) {
    /* which example to show.  These correspond to the pictures above. */
    if (["1" equal args[0]]) {
      /* create a new label. */
      GtkLabel label = [GtkLabel new "gtk_hbox_new (FALSE, 0);"];

      /* Align the label to the left side.  We'll discuss this function and 
       * others in the section on Widget Attributes. */
      [label set_alignment (0, 0)];

      /* Pack the label into the vertical box (vbox box1).  Remember that 
       * widgets added to a vbox will be packed one on top of the other in
       * order. */
      [box1 pack_start (label, FALSE, FALSE, 0)];

      /* show the label */
      [label show];
      /* call our make box method. */
      GtkWidget box2 = [self makeWithHomogeneous FALSE
			     Spacing 0
			     Expand FALSE
			     Fill FALSE
			     Padding 0];
      [box1 pack_start (box2, FALSE, FALSE, 0)];
      [box2 show];

      box2 = [self makeWithHomogeneous FALSE
		   Spacing 0
		   Expand TRUE
		   Fill FALSE
		   Padding 0];
      [box1 pack_start (box2, FALSE, FALSE, 0)];
      [box2 show];

      box2 = [self makeWithHomogeneous FALSE
		   Spacing 0
		   Expand TRUE
		   Fill TRUE
		   Padding 0];
      [box1 pack_start (box2, FALSE, FALSE, 0)];
      [box2 show];

      /* creates a separator, we'll learn more about these later, 
       * but they are quite simple. */
      GtkHSeparator separator = [GtkHSeparator new];

      /* pack the separator into the vbox.  Remember each of these
       * widgets are being packed into a vbox, so they'll be stacked
       * vertically. */

      [box1 pack_start (separator, FALSE, FALSE, 0)];
      [separator show];

      /* create another new label, and show it. */
      label = [GtkLabel new "gtk_hbox_new (TRUE, 0);"];
      [label set_alignment (0,0)];
      [box1 pack_start (label, FALSE, FALSE, 0)];
      [label show];

      box2 = [self makeWithHomogeneous TRUE
		   Spacing 0
		   Expand TRUE
		   Fill FALSE
		   Padding 0];
      [box1 pack_start (box2, FALSE, FALSE, 0)];
      [box2 show];

      box2 = [self makeWithHomogeneous TRUE
		   Spacing 0
		   Expand TRUE
		   Fill TRUE
		   Padding 0];
      [box1 pack_start (box2, FALSE, FALSE, 0)];
      [box2 show];

      /* another new separator. */
      separator = [GtkHSeparator new];
      [box1 pack_start (separator, FALSE, TRUE, 5)];
      [separator show];

    } else if (["2" equal args[0]]) {
      /* create a new label, remember box1 is a vbox as created 
       * near the beginning of selector(int main MutableArray) */
      GtkLabel label = [GtkLabel new "gtk_hbox_new (FALSE, 10);"];
      [label set_alignment (0,0)];
      [box1 pack_start (label, FALSE, FALSE, 0)];
      [label show];
              
      GtkWidget box2 = [self makeWithHomogeneous FALSE
			     Spacing 10
			     Expand TRUE
			     Fill FALSE
			     Padding 0];
      [box1 pack_start (box2, FALSE, FALSE, 0)];
      [box2 show];

      box2 = [self makeWithHomogeneous FALSE
		   Spacing 10
		   Expand TRUE
		   Fill TRUE
		   Padding 0];
      [box1 pack_start (box2, FALSE, FALSE, 0)];
      [box2 show];

      GtkHSeparator separator = [GtkHSeparator new];
      [box1 pack_start (separator, FALSE, TRUE, 5)];
      [separator show];

      label = [GtkLabel new "gtk_hbox_new (FALSE, 0);"];
      [label set_alignment (0,0)];
      [box1 pack_start (label, FALSE, FALSE, 0)];
      [label show];

      box2 = [self makeWithHomogeneous FALSE
		   Spacing 0
		   Expand TRUE
		   Fill FALSE
		   Padding 10];
      [box1 pack_start (box2, FALSE, FALSE, 0)];
      [box2 show];

      box2 = [self makeWithHomogeneous FALSE
		   Spacing 0
		   Expand TRUE
		   Fill TRUE
		   Padding 10];
      [box1 pack_start (box2, FALSE, FALSE, 0)];
      [box2 show];
              
      separator = [GtkHSeparator new];
      [box1 pack_start (separator, FALSE, TRUE, 5)];
      [separator show];
    } else if (["3" equal args[0]]) {
      /* This demonstrates the ability to use gtk_box_pack_end() to
       * right justify widgets.  First, we create a new box as before. */
      GtkWidget box2 = [self makeWithHomogeneous FALSE
			     Spacing 0
			     Expand FALSE
			     Fill FALSE
			     Padding 0];
      /* create the label that will be put at the end. */
      GtkLabel label = [GtkLabel new "end"];
      /* pack it using [GtkBox pack_end], so it is put on the right side
       * of the hbox created in the make_box() call. */
      [GtkHBox(box2) pack_end (label, FALSE, FALSE, 0)];
      /* show the label. */
      [label show];
              
      /* pack box2 into box1 (the vbox remember ? :) */
      [box1 pack_start (box2, FALSE, FALSE, 0)];
      [box2 show];
              
      /* a separator for the bottom. */
      GtkSeparator separator = [GtkHSeparator new];
      /* this explicitly sets the separator to 400 pixels wide by 5 pixels
       * high.  This is so the hbox we created will also be 400 pixels wide,
       * and the "end" label will be separated from the other labels in the
       * hbox.  Otherwise, all the widgets in the hbox would be packed as
       * close together as possible. */
      [separator set_usize (400, 5)];
      /* pack the separator into the vbox (box1) created near the start 
       * of main() */
      [box1 pack_start (separator, FALSE, TRUE, 5)];
      [separator show];
    }

    /* Create another new hbox.. remember we can use as many as we need! */
    GtkHBox quitbox = [GtkHBox new (FALSE, 0)];
          
    /* Our quit button. */
    GtkButton button = [GtkButton new_with_label "Quit"];
          
    /* setup the signal to destroy the window.  Remember that this will send
     * the "destroy" signal to the window which will be caught by our signal
     * handler as defined above. */
    [button connect "clicked" to window using selector (void destroy)];
    /* pack the button into the quitbox.
     * The last 3 arguments to [GtkBox pack_start] are: expand, fill, padding. */
    [quitbox pack_start (button, TRUE, FALSE, 0)];
    /* pack the quitbox into the vbox (box1) */
    [box1 pack_start (quitbox, FALSE, FALSE, 0)];
          
    /* pack the vbox (box1) which now contains all our widgets, into the
     * main window. */
    [window add box1];

    /* and show everything left */
    [button show];
    [quitbox show];
    [box1 show];
    /* Showing the window last so everything pops up at once. */
    [window show];
  } else {
    [[[stdio err] print "usage: packbox num, where num is 1, 2, or 3."] nl];
    return 1;
  }

  /* And of course, our main function. */
  [gtomk main];
}

<doc> Make a new hbox filled with button-labels. Arguments for the 
variables we're interested are passed in to this function. 
We do not show the box, but do show everything inside.
</doc>
GtkWidget
  makeWithHomogeneous boolean hg
              Spacing int spacing
               Expand boolean expand
                 Fill boolean fill
              Padding int padding
{
  GtkHBox box;
  GtkWidget button;
  MutableByteString padstr = [MutableByteString new];

  /* create a new hbox with the appropriate homogeneous and spacing
   * settings */
  box = [GtkHBox new (hg, spacing)];
  /* create a series of buttons with the appropriate settings */

  button = [GtkButton new_with_label "gtk_box_pack"];
  [box pack_start (button, expand, fill, padding)];
  [button show];

  button = [GtkButton new_with_label "(box,"];
  [box pack_start (button, expand, fill, padding)];
  [button show];

  button = [GtkButton new_with_label "button, "];
  [box pack_start (button, expand, fill, padding)];
  [button show];
          
  /* create a button with the label depending on the value of
   * expand. */
  if (expand)
    button = [GtkButton new_with_label "TRUE,"];
  else
    button = [GtkButton new_with_label "FALSE,"];
  [box pack_start (button, expand, fill, padding)];
  [button show];

  if (fill)          
    button = [GtkButton new_with_label "TRUE,"];
  else
    button = [GtkButton new_with_label "FALSE,"];
  [box pack_start (button, expand, fill, padding)];
  [button show];

  [padstr print padding];          
  button = [GtkButton new_with_label padstr];
  [box pack_start (button, expand, fill, padding)];
  [button show];

  = box;
}

end;

implementation instance
PackBox

end;
