<copyright> gtomk Tappli example,
    A rewrite in TOM of the original neil/Tappli.py example,
    as it appears in the pygtk-0.3.0 distribution.
    By <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: Tappli.t,v 1.6 1999/02/17 23:32:05 tiggr Exp $</id>
    </copyright>

implementation class
Application: State, Constants

int
  main MutableArray arguments
{
  [gtomk init arguments];
  [self new];
  [gtomk main];
}

end;

implementation instance
Application
{
  GtkWindow window;
  GtkVBox vbox;
  GtkMenuBar menubar;
  GtkMenu w_filemenu;
  GtkMenu w_editmenu;
  GtkList listbox;
  int idle_count;
}

id
  init
{
  window = [GtkWindow new GTK_WINDOW_TOPLEVEL];
  [window set_title "Test application"];

  /* When the window is closed, we want to quit this application by
     invoking gtk_main_quit(), i.e. invoking [gtomk main_quit].  However,
     the delete_event signal passes the event as an argument, and expects
     a boolean to be returned.  The [gtomk main_quit] method does not
     accept any arguments, and returns void: a mismatch.  Passing
     `overrideArguments: YES' causes the mismatch to be ignored.  */
  [window connect "delete_event" to [gtomk self]
	  using selector (void main_quit) overrideArguments: YES];

  vbox = [GtkVBox new (TRUE, 0)];
  [self init_menu];
  [self init_list];
  [self init_button];

  [window add vbox];
  [vbox show];
  [window show];

  [gtomk idle_add self using selector (void idle)];
}

void
  quit
{
  [gtomk main_quit];
}

void
  doit
{
  MutableArray z = [MutableObjectArray withCapacity 10];
  MutableByteString buf = [MutableByteString new];
  int x;

  for (x = 10; x < 20; x++)
    {
      [buf truncate 0];
      [buf print ("line ", x)];
      GtkListItem item = [GtkListItem new_with_label buf];
      [item show];
      [z add item];
    }

  [listbox append_items z];
}

protected void
  init_menu
{
  menubar = [GtkMenuBar new];
  w_filemenu = [GtkMenu new];
  GtkMenuItem filemenu = [GtkMenuItem new_with_label "File"];
  [filemenu set_submenu w_filemenu];
  [filemenu show];

  GtkMenuItem item = [GtkMenuItem new_with_label "New"];
  [w_filemenu append item];
  [item connect "activate" to self using selector (void process_file_new)];
  [item show];
  item = [GtkMenuItem new_with_label "Open..."];
  [w_filemenu append item];
  [item connect "activate" to self using selector (void process_file_open)];
  [item show];
  item = [GtkMenuItem new_with_label "Save"];
  [w_filemenu append item];
  [item connect "activate" to self using selector (void process_file_save)];
  [item show];
  item = [GtkMenuItem new_with_label "Save As..."];
  [w_filemenu append item];
  [item connect "activate" to self using selector (void process_file_save_as)];
  [item show];
  item = [GtkMenuItem new_with_label "Close"];
  [w_filemenu append item];
  [item connect "activate" to self using selector (void process_file_close)];
  [item show];
  item = [GtkMenuItem new_with_label "Quit"];
  [w_filemenu append item];
  [item connect "activate" to self using selector (void process_file_quit)];
  [item show];

  w_editmenu = [GtkMenu new];
  GtkMenuItem editmenu = [GtkMenuItem new_with_label "Edit"];
  [editmenu set_submenu w_editmenu];
  [editmenu show];

  item = [GtkMenuItem new_with_label "Cut"];
  [w_editmenu append item];
  [item connect "activate" to self using selector (void process_edit_cut)];
  [item show];
  item = [GtkMenuItem new_with_label "Copy"];
  [w_editmenu append item];
  [item connect "activate" to self using selector (void process_edit_copy)];
  [item show];
  item = [GtkMenuItem new_with_label "Paste"];
  [w_editmenu append item];
  [item connect "activate" to self using selector (void process_edit_paste)];
  [item show];

  [menubar append filemenu];
  [menubar append editmenu];
  [vbox pack_start (menubar, FALSE, TRUE, 0)];
  [menubar show];
}

protected void
  init_list
{
  GtkScrolledWindow c = [GtkScrolledWindow new (nil, nil)];
  [c set_usize (250, 200)];
  listbox = [GtkList new];
  [listbox set_selection_mode GTK_SELECTION_MULTIPLE];
  [c add listbox];
  [vbox pack_start (c, TRUE, TRUE, 0)];

  MutableByteString buf = [MutableByteString new];
  int x;

  for (x = 0; x < 10; x++)
    {
      [buf truncate 0];
      [buf print ("line ", x)];
      GtkListItem item = [GtkListItem new_with_label buf];
      [item show];
      [listbox add item];
    }

  [listbox show];
  [c show];
}

protected void
  init_button
{
  GtkTable t = [GtkTable new (1, 2, TRUE)];
  GtkButton b1 = [GtkButton new_with_label "Do it!"];
  [b1 connect "clicked" to self using selector (void doit)];
  GtkButton b2 = [GtkButton new_with_label "Quit"];
  [b2 connect "clicked" to self using selector (void quit)];
  [t attach (b1, 0, 1, 0, 1, 0, 0, 2, 2)];
  [t attach (b2, 1, 2, 0, 1, 0, 0, 2, 2)];
  [vbox pack_end (t, FALSE, TRUE, 0)];
  [b1 show];
  [b2 show];
  [t show];
}

void
  process_file_new
{
  [[[stdio out] print cmd] nl];
}

void
  process_file_open
{
  GtkFileSelection fs = [GtkFileSelection new "Open"];
  // This does not run modal...
  // Fri Apr  3 00:37:20 1998, tiggr@gerbil.org
  [[fs ok_button] connect "clicked" to fs using selector (void destroy)];
  [fs show];
}

void
  process_file_save
{
  [[[stdio out] print cmd] nl];
}

void
  process_file_save_as
{
  GtkFileSelection fs = [GtkFileSelection new "Save As"];
  [fs show];
}

void
  process_file_close
{
  [[[stdio out] print cmd] nl];
}

void
  process_file_quit
{
  [[[stdio out] print cmd] nl];
}

void
  process_edit_cut
{
  [[[stdio out] print cmd] nl];
}

void
  process_edit_copy
{
  [[[stdio out] print cmd] nl];
}

void
  process_edit_paste
{
  [[[stdio out] print cmd] nl];
}

void
  idle
{
  if (!(++idle_count % 1000))
    [[[stdio out] print ("Idle: ", idle_count)] nl];

  // We do not want to keep this going, since it makes the GUI *dog* slow.
  // Sun Apr  5 16:28:02 1998, tiggr@gerbil.org
  // [gtomk idle_add self using selector (void idle)];
}

end;
