<copyright> TOM/Gtk tom-oclock example of TOMWidget.
    By <a href="mailto:tiggr@gerbil.org">Pieter Schoenmakers</a>

    Copyright &copy; 1999 Pieter J. Schoenmakers

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: OClock.t,v 1.1 1999/04/25 18:42:45 tiggr Exp $</id>
    </copyright>

<c>
#include <libgnomeui/libgnomeui.h>
#include <math.h>

#include <gtomk/tomwidget.h>

extern GtkTomwidgetClass tomwidget_original_methods;
</c>

implementation class
OClock: TOMWidget, Constants

int
  main MutableArray args
{
  [gtomk init args];

  GtkWindow window = [GtkWindow new GTK_WINDOW_TOPLEVEL];
  [window connect "delete_event" to [gtomk self]
	  using selector (void main_quit) overrideArguments: YES];
  OClock clock = [OClock new];
  [window add clock];

  [clock show];
  [window show];

  /* Go for it!  */
  [gtomk main];
}

end;

implementation instance
OClock

(int, int)
  signal_size_request
{
  = (100, 100);
}

void
  signal_size_allocate (int, int, int, int) (x, y, w, h)
{
  pointer p = object;

  <c>
    {
      GtkAllocation allocation = {x, y, w, h};
      GtkWidget *widget = GTK_WIDGET (p);

      widget->allocation = allocation;

      if (GTK_WIDGET_REALIZED (widget))
	{
	  gdk_window_move_resize (widget->window,
				  allocation.x, allocation.y,
				  allocation.width, allocation.height);

	}
    }
  </c>
}

void
  signal_realize
{
  pointer p = object;

<c>
  {
    GtkWidget *widget = GTK_WIDGET (p);
    GdkWindowAttr attributes = {};
    gint attributes_mask;

    GTK_WIDGET_SET_FLAGS (widget, GTK_REALIZED);

    attributes.x = widget->allocation.x;
    attributes.y = widget->allocation.y;
    attributes.width = widget->allocation.width;
    attributes.height = widget->allocation.height;
    attributes.wclass = GDK_INPUT_OUTPUT;
    attributes.window_type = GDK_WINDOW_CHILD;
    attributes.event_mask
      = (gtk_widget_get_events (widget) | GDK_EXPOSURE_MASK
	 | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK
	 | GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK);
    attributes.visual = gtk_widget_get_visual (widget);
    attributes.colormap = gtk_widget_get_colormap (widget);

    attributes_mask = GDK_WA_X | GDK_WA_Y | GDK_WA_VISUAL | GDK_WA_COLORMAP;
    widget->window = gdk_window_new (widget->parent->window,
				     &attributes, attributes_mask);

    widget->style = gtk_style_attach (widget->style, widget->window);
    gdk_window_set_user_data (widget->window, widget);
    gtk_style_set_background (widget->style, widget->window, GTK_STATE_ACTIVE);
  }
</c>
}

int
  signal_expose_event pointer ee
{
  pointer p = object;

<c>
  {
    GdkEventExpose *event = ee;
    GtkWidget *widget = GTK_WIDGET (p);
    GdkPoint points[3];
    gdouble s,c;
    gdouble theta;
    gint xc, yc;
    gint tick_length;
    gint i;

    if (event->count > 0)
      return FALSE;

    gdk_window_clear_area (widget->window,
			   0, 0,
			   widget->allocation.width,
			   widget->allocation.height);

    xc = widget->allocation.width/2;
    yc = widget->allocation.height/2;

    /* Draw ticks */
    for (i=0; i<25; i++)
      {
	theta = (i*M_PI/18. - M_PI/6.);
	s = sin(theta);
	c = cos(theta);

#define pointer_width 10
#define radius (widget->allocation.width/2.1)

	tick_length = (i%6 == 0) ? pointer_width : pointer_width/2;
      
	gdk_draw_line (widget->window,
		       widget->style->fg_gc[widget->state],
		       xc + c*(radius - tick_length),
		       yc - s*(radius - tick_length),
		       xc + c*radius,
		       yc - s*radius);
      }

    
#define angle 0

    /* Draw pointer */
    s = sin(angle);
    c = cos(angle);

    points[0].x = xc + s*pointer_width/2;
    points[0].y = yc + c*pointer_width/2;
    points[1].x = xc + c*radius;
    points[1].y = yc - s*radius;
    points[2].x = xc - s*pointer_width/2;
    points[2].y = yc - c*pointer_width/2;

    gtk_draw_polygon (widget->style,
		      widget->window,
		      GTK_STATE_NORMAL,
		      GTK_SHADOW_OUT,
		      points, 3,
		      TRUE);

    return FALSE;
  }
</c>
}

end;
