<copyright> gdomk Font class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GDOMK.  GDOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GDOMK distribution; see the file COPYING.LIB.

    <id>$Id: Font.t,v 1.4 1998/04/24 20:25:29 yacc Exp $</id>
    </copyright>

<c>
#include "glue.h"
#include <tom/util.h>
</c>

implementation class
GdkFont: GdkWrapper

/* methods: */

instance (id) 
  font_load String name
{
  pointer gdkfont;
  <c> {
    int len;
    char *cname;
    DECL_USEL (tom, _pi__byteStringContents);
    
    C_STRING_WITH_TOM_STRING (cname, len, name);
    gdkfont = gdk_font_load (cname);
  } </c>
  if(!gdkfont)
    = nil;
  else
    = [GdkFont proxy gdkfont create: YES];
}

instance (id)
  fontset_load String name
{
  pointer gdkfont;
  <c> {
    int len;
    char *cname;
    DECL_USEL (tom, _pi__byteStringContents);
    
    C_STRING_WITH_TOM_STRING (cname, len, name);
    gdkfont = gdk_fontset_load (cname);
  } </c>
  if(!gdkfont)
    = nil;
  else
    = [GdkFont proxy gdkfont create: YES];
}

end;

implementation instance
GdkFont

<doc> Return the {GdkFont} for which this object stands.  </doc>
pointer
  gdkFont
{
  = object;
}

/* methods: */

int (res)
  id
{
  pointer font = object;
  <c> res = gdk_font_id ((GdkFont *) font); </c>
}

boolean (res)
  equal GdkFont b
{
  pointer fonta = object;
  pointer fontb = [b gdkFont];
  <c> res = gdk_font_equal ((GdkFont *) fonta, (GdkFont *) fontb); </c>
}

int (res)
  string_width String str
{
  pointer font = object;
  <c> {
    int len;
    char *cstr;
    DECL_USEL (tom, _pi__byteStringContents);
    
    C_STRING_WITH_TOM_STRING (cstr, len, str);
    res = gdk_text_width ((GdkFont *) font, cstr, len);
  } </c>
}

int (res)
  text_width String str
{
  = [self string_width str];	/* TOM strings may contain zeros, right? */
}

int (res)
  char_width byte ch
{
  pointer font = object;
  <c> res = gdk_char_width ((GdkFont *) font, (gchar) ch); </c>
}

int (res)
  char_measure byte ch
{
  pointer font = object;
  <c> res = gdk_char_measure ((GdkFont *) font, (gchar) ch); </c>
}

int (res)
  string_measure String str
{
  pointer font = object;
  <c> {
    int len;
    char *cstr;
    DECL_USEL (tom, _pi__byteStringContents);
    
    C_STRING_WITH_TOM_STRING (cstr, len, str);
    res = gdk_text_measure ((GdkFont *) font, cstr, len);
  } </c>
}

int (res)
  text_measure String str
{
  = [self string_measure str];
}

int (res)
  ascent
{
  pointer font = object;
  <c> res = ((GdkFont *) font)->ascent; </c>
}

int (res)
  descent
{
  pointer font = object;
  <c> res = ((GdkFont *) font)->descent; </c>
}

end;
