<copyright> gdomk GC class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GDOMK.  GDOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GDOMK distribution; see the file COPYING.LIB.

    <id>$Id: GC.t,v 1.5 1998/06/04 17:07:45 yacc Exp $</id>
    </copyright>

<c>
#include <stdlib.h>
#include "glue.h"
</c>

implementation class
GdkGC: GdkWrapper

// methods

end;

implementation instance
GdkGC

<doc> Return the {GdkGC} for which this object stands.  </doc>
pointer
  gdkGC
{
  = object;
}

// methods

private void
  unref
{
  pointer gc = object;
  <c> gdk_gc_unref ((GdkGC *) gc); </c>
}

void
  dealloc
{
  if(!!object)
    [self unref];
}

id
  copy GdkGC fromGC
{
  pointer srcgc = [fromGC gdkGC];
  pointer destgc = object;
  <c> gdk_gc_copy ((GdkGC *) destgc, (GdkGC *) srcgc); </c>
}

GdkGCValues
  get_values
{
  pointer gc = object;
  pointer gcvalues;
  <c> 
    gcvalues = malloc (sizeof(GdkGCValues));
    gdk_gc_get_values ((GdkGC *) gc, (GdkGCValues *) gcvalues);
  </c>
  = [[GdkGCValues alloc] init gcvalues];
}

void
  set_foreground GdkColor col
{
  pointer pcol = [col gdkColor];
  pointer pgc = object;
  <c> gdk_gc_set_foreground ((GdkGC *) pgc, (GdkColor *) pcol); </c>
}

void
  set_background GdkColor col
{
  pointer pcol = [col gdkColor];
  pointer pgc = object;
  <c> gdk_gc_set_background ((GdkGC *) pgc, (GdkColor *) pcol); </c>
}

void
  set_font GdkFont font
{
  pointer pfont = [font gdkFont];
  pointer pgc = object;
  <c> gdk_gc_set_font ((GdkGC *) pgc, (GdkFont *) pfont); </c>
}

void
  set_fill int GdkFill_VALUE
{
  pointer pgc = object;
  <c> gdk_gc_set_fill ((GdkGC *) pgc, (GdkFill) GdkFill_VALUE); </c>
}

void
  set_tile GdkPixmap pm
{
  pointer ppm = [pm gdkPixmap];
  pointer pgc = object;
  <c> gdk_gc_set_tile ((GdkGC *) pgc, (GdkPixmap *) ppm); </c>
}

void
  set_stipple GdkPixmap pm
{
  pointer ppm = [pm gdkPixmap];
  pointer pgc = object;
  <c> gdk_gc_set_stipple ((GdkGC *) pgc, (GdkPixmap *) ppm); </c>
}

void
  set_ts_origin (int, int) (x, y)
{
  pointer pgc = object;
  <c> gdk_gc_set_ts_origin ((GdkGC *) pgc, x, y); </c>
}

void
  set_clip_origin (int, int) (x, y)
{
  pointer pgc = object;
  <c> gdk_gc_set_clip_origin ((GdkGC *) pgc, x, y); </c>
}

void
  set_exposures int exp
{
  pointer pgc = object;
  <c> gdk_gc_set_exposures ((GdkGC *) pgc, exp); </c>
}

void
  set_subwindow int sbw
{
  pointer pgc = object;
  <c> gdk_gc_set_subwindow ((GdkGC *) pgc, sbw); </c>
}

void
  set_line_attributes (int, int, int, int) (width, style, cap, join)
{
  pointer pgc = object;
  <c> gdk_gc_set_line_attributes ((GdkGC *) pgc, width, style, cap, join); </c>
}

void
  set_clip_mask GdkBitmap bm
{
  pointer pbm = [bm gdkBitmap];
  pointer pgc = object;
  <c> gdk_gc_set_clip_mask ((GdkGC *) pgc, (GdkBitmap *) pbm); </c>
}

void
  set_clip_rectangle GdkRectangle rec
{
  pointer prec = [rec gdkRectangle];
  pointer pgc = object;
  <c> gdk_gc_set_clip_rectangle ((GdkGC *) pgc, (GdkRectangle *) prec); </c>
}

/*
void
  set_clip_region GdkRegion rg
{
  pointer prg = [rg gdkRegion];
  pointer pgc = object;
  <c> gdk_gc_set_clip_region ((GdkGC *) pgc, (GdkRegion *) prg); </c>
}
*/
end;

implementation class GdkGCValues : State
end;

implementation instance GdkGCValues
{
  <doc> hold our object. </doc>
  pointer object;
}

id
  init pointer data
{
  object = data;
  = self;
}

GdkColor
  foreground
{
  pointer col;
  pointer gcvalues = object;
  <c> col = &(((GdkGCValues *) gcvalues)->foreground); </c>
  = [[GdkColor alloc] initFromPtr col];
}

GdkColor
  background
{
  pointer col;
  pointer gcvalues = object;
  <c> col = &(((GdkGCValues *) gcvalues)->background); </c>
  = [[GdkColor alloc] initFromPtr col];
}

GdkFont
  font
{
  pointer font;
  pointer gcvalues = object;
  <c> font = (((GdkGCValues *) gcvalues)->font); </c>
  = [GdkFont proxy font create: YES];
}

GdkPixmap
  tile
{
  pointer pm;
  pointer gcvalues = object;
  <c> pm = (((GdkGCValues *) gcvalues)->tile); </c>
  = [GdkPixmap proxy pm create: YES];
}

GdkPixmap
  stipple
{
  pointer pm;
  pointer gcvalues = object;
  <c> pm = (((GdkGCValues *) gcvalues)->stipple); </c>
  = [GdkPixmap proxy pm create: YES];
}

GdkPixmap
  clip_mask
{
  pointer pm;
  pointer gcvalues = object;
  <c> pm = (((GdkGCValues *) gcvalues)->clip_mask); </c>
  = [GdkPixmap proxy pm create: YES];
}

int (GdkSubwindowMode_VALUE)
  subwindow_mode
{
  pointer gcvalues = object;
  <c>
    GdkSubwindowMode_VALUE = (((GdkGCValues *) gcvalues)->subwindow_mode); 
  </c>
}

int (res)
  ts_x_origin
{
  pointer gcvalues = object;
  <c> res = (((GdkGCValues *) gcvalues)->ts_x_origin); </c>
}

int (res)
  ts_y_origin
{
  pointer gcvalues = object;
  <c> res = (((GdkGCValues *) gcvalues)->ts_y_origin); </c>
}

int (res)
  clip_x_origin
{
  pointer gcvalues = object;
  <c> res = (((GdkGCValues *) gcvalues)->clip_x_origin); </c>
}

int (res)
  clip_y_origin
{
  pointer gcvalues = object;
  <c> res = (((GdkGCValues *) gcvalues)->clip_y_origin); </c>
}

int (res)
  graphics_exposures
{
  pointer gcvalues = object;
  <c> res = (((GdkGCValues *) gcvalues)->graphics_exposures); </c>
}

int (res)
  line_width
{
  pointer gcvalues = object;
  <c> res = (((GdkGCValues *) gcvalues)->line_width); </c>
}

int (GdkLineStyle_VALUE)
  line_style
{
  pointer gcvalues = object;
  <c> GdkLineStyle_VALUE = (((GdkGCValues *) gcvalues)->line_style); </c>
}

int (GdkCapStyle_VALUE)
  cap_style
{
  pointer gcvalues = object;
  <c> GdkCapStyle_VALUE = (((GdkGCValues *) gcvalues)->cap_style); </c>
}

int (GdkJoinStyle_VALUE)
  join_style
{
  pointer gcvalues = object;
  <c> GdkJoinStyle_VALUE = (((GdkGCValues *) gcvalues)->join_style); </c>
}

void
  dealloc
{
  pointer gcvalues = object;
  <c> free (gcvalues); </c>
}

end;
