<copyright> gdomk Pixmap class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GDOMK.  GDOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GDOMK distribution; see the file COPYING.LIB.

    <id>$Id: Pixmap.t,v 1.6 1998/07/30 18:32:17 yacc Exp $</id>
    </copyright>

<c>
#include <tom/util.h>
#include "glue.h"
</c>

implementation class
GdkPixmap: GdkDrawable

instance (id)
  new (GdkWindow, int, int, int) (window, width, height, depth)
{
  pointer p, window_obj = [window gdkWindow];
<c>
  p = gdk_pixmap_new (window_obj, width, height, depth);
</c>

  = [[self alloc] init p];

<c>
  gdk_pixmap_unref (p);
</c>
}

(instance (id), GdkBitmap) (newid, mask)
  create_from_xpm (GdkWindow, GdkColor, String) (window, transcol, filename)
{
  pointer cres, window_obj = [window gdkWindow];
  pointer cmask, ccolor;
  if (transcol)
    ccolor = [transcol gdkColor];
  <c> {
    char *cname;
    int len;
    DECL_USEL (tom, _pi__byteStringContents);

    C_STRING_WITH_TOM_STRING (cname, len, filename);

    cres = gdk_pixmap_create_from_xpm (window_obj, (GdkBitmap **)&cmask, ccolor, cname);
  } </c>

  newid = [[self alloc] init cres];
  <c>
    gdk_pixmap_unref (cres);
  </c>
  if (cmask) 
    mask = [GdkBitmap proxy cmask create: YES];
}

//GdkPixmap* gdk_pixmap_create_from_data	(GdkWindow  *window,
//					 gchar	    *data,
//					 gint	     width,
//					 gint	     height,
//					 gint	     depth,
//					 GdkColor   *fg,
//					 GdkColor   *bg);
//GdkPixmap* gdk_pixmap_colormap_create_from_xpm 
//                                        (GdkWindow   *window,
//					 GdkColormap *colormap,
//					 GdkBitmap  **mask,
//					 GdkColor    *transparent_color,
//					 const gchar *filename);
//GdkPixmap* gdk_pixmap_create_from_xpm_d (GdkWindow  *window,
//					 GdkBitmap **mask,
//					 GdkColor   *transparent_color,
//					 gchar	   **data);
//GdkPixmap* gdk_pixmap_colormap_create_from_xpm_d 
//                                        (GdkWindow   *window,
//					 GdkColormap *colormap,
//					 GdkBitmap  **mask,
//					 GdkColor    *transparent_color,
//					 gchar     **data);

end;

implementation instance
GdkPixmap

<doc> Return the {GdkPixmap} for which this object stands.  </doc>
pointer
  gdkPixmap
{
  = object;
}

<doc> Designated initializer.  Reference the pixmap.  </doc>
id
  init pointer p
{
  = [super init p];
<c>
  gdk_pixmap_ref (p);
</c>
}

<doc> Release the pixmap {object} if not done yet.  </doc>
void
  dealloc
{
  if (!!object)
    {
      pointer obj = object;
<c>
      gdk_pixmap_unref (obj);
</c>
      [super dealloc];
    }
}

end;
