<copyright> gdomk Visual class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GDOMK.  GDOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GDOMK distribution; see the file COPYING.LIB.

    <id>$Id: Visual.t,v 1.2 1998/04/04 00:27:21 tiggr Exp $</id>
    </copyright>

<c>
#include "glue.h"
</c>

implementation class
GdkVisual: GdkWrapper

int (result)
  get_best_depth
{
<c>
  result = gdk_visual_get_best_depth ();
</c>
}

int (GDK_VISUAL_something)
  get_best_type
{
<c>
  GDK_VISUAL_something = gdk_visual_get_best_type ();
</c>
}

GdkVisual (visual)
  gdk_visual_get_system
{
  pointer p;
<c>
  p = gdk_visual_get_system ();
</c>
  if (!!p)
    visual = [GdkVisual proxy p create: YES];
}

GdkVisual (visual)
  gdk_visual_get_best
{
  pointer p;
<c>
  p = gdk_visual_get_best ();
</c>
  if (!!p)
    visual = [GdkVisual proxy p create: YES];
}

GdkVisual (visual)
  get_best_with_depth int depth
{
  pointer p;
<c>
  p = gdk_visual_get_best_with_depth (depth);
</c>
  if (!!p)
    visual = [GdkVisual proxy p create: YES];
}

GdkVisual (visual)
  get_best_with_type int GDK_VISUAL_something
{
  pointer p;
<c>
  p = gdk_visual_get_best_with_type (GDK_VISUAL_something);
</c>
  if (!!p)
    visual = [GdkVisual proxy p create: YES];
}

GdkVisual (visual)
  get_best_with_both (int, int) (depth, GDK_VISUAL_something)
{
  pointer p;
<c>
  p = gdk_visual_get_best_with_both (depth, GDK_VISUAL_something);
</c>
  if (!!p)
    visual = [GdkVisual proxy p create: YES];
}

///* Actually, these are no-ops... */
//GdkVisual* gdk_visual_ref (GdkVisual *visual);
//void	   gdk_visual_unref (GdkVisual *visual);

IntArray
  query_depths
{
  int i, n, v;

<c>
  {
    gint *d, count;
    gdk_query_depths (&d, &count);
    n = count;
</c>

    MutableIntArray depths = [MutableIntArray withCapacity n];
    for (i = 0; i < n; i++)
      {
<c>
	v = d[i];
</c>
	depths[i] = v;
      }
<c>
  }
</c>
  = depths;
}

IntArray
  query_visual_types
{
  int i, n, v;

<c>
  {
    GdkVisualType *types;
    gint count;
    gdk_query_visual_types (&types, &count);
    n = count;
</c>

    MutableIntArray visual_types = [MutableIntArray withCapacity n];
    for (i = 0; i < n; i++)
      {
<c>
	v = types[i];
</c>
	visual_types[i] = v;
      }
<c>
  }
</c>
  = visual_types;
}

Array
  gdk_list_visuals
{
  MutableArray visuals = [MutableArray new];
  pointer p, tmp;
<c>
  {
    GList *list = gdk_list_visuals ();
    tmp = list;
</c>
    while (!!tmp)
      {
<c>
	p = ((GList *) tmp)->data;
	tmp = ((GList *) tmp)->next;
</c>
	GdkVisual visual = [GdkVisual proxy p create: YES];
	[visuals add visual];
      }
<c>
    g_list_free (list);
  }
</c>
  = visuals;
}

end;

implementation instance
GdkVisual

<doc> Return the {GdkVisual} for which this object stands.  </doc>
pointer
  gdkVisual
{
  = object;
}

end;
