<copyright> gtomk Box class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: Box.t,v 1.5 1998/04/14 13:24:53 tiggr Exp $</id>
    </copyright>

<gtk_version>1.0.0</gtk_version>

<c>
#include "glue.h"
</c>

implementation class
GtkBox: GtkContainer

end;

implementation instance
GtkBox

<doc> Return the {gtkBox} for which this object stands.  </doc>
pointer
  gtkBox
{
  = object;
}

void
  pack_start (GtkWidget, boolean, boolean, int) (child, expand, fill, padding)
{
  pointer obj = object;
  pointer child_obj = [child gtkWidget];

<c>
  gtk_box_pack_start (obj, child_obj, expand, fill, padding);
</c>
}

void
  pack_end (GtkWidget, boolean, boolean, int) (child, expand, fill, padding)
{
  pointer obj = object, child_obj = [child gtkWidget];

<c>
  gtk_box_pack_end (obj, child_obj, expand, fill, padding);
</c>
}

void
  pack_start_defaults GtkWidget widget
{
  pointer obj = object, widget_obj = [widget gtkWidget];
<c>
  gtk_box_pack_start_defaults (obj, widget_obj);
</c>
}

void
  pack_end_defaults GtkWidget widget
{
  pointer obj = object, widget_obj = [widget gtkWidget];
<c>
  gtk_box_pack_end_defaults (obj, widget_obj);
</c>
}

void
  set_homogeneous boolean homogeneous
{
  pointer obj = object;
<c>
  gtk_box_set_homogeneous (obj, homogeneous);
</c>
}

void
  set_spacing int spacing
{
  pointer obj = object;
<c>
  gtk_box_set_spacing (obj, spacing);
</c>
}

void
  reorder_child (GtkWidget, int) (widget, pos)
{
  pointer obj = object, widget_obj = [widget gtkWidget];
<c>
  gtk_box_reorder_child (obj, widget_obj, pos);
</c>
}

(boolean, boolean, int, int) (expand, fill, padding, GTK_PACK_something)
  query_child_packing GtkWidget widget
{
  pointer obj = object, widget_obj = [widget gtkWidget];
<c>
  {
    gint exp, fil, pad;
    GtkPackType pack;

    gtk_box_query_child_packing (obj, widget_obj, &exp, &fil, &pad, &pack);
    expand = exp;
    fill = fil;
    padding = pad;
    GTK_PACK_something = pack;
  }
</c>
}

void
  set_child_packing (GtkWidget, boolean, boolean, int, int)
		    (widget, expand, fill, padding, GTK_PACK_something)
{
  pointer obj = object, widget_obj = [widget gtkWidget];
<c>
  gtk_box_set_child_packing (obj, widget_obj, expand, fill, padding,
			     GTK_PACK_something);
</c>
}

end;
