<copyright> gtomk Button class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: Button.t,v 1.5 1998/04/14 13:24:54 tiggr Exp $</id>
    </copyright>

<gtk_version>1.0.0</gtk_version>

<c>
#include "glue.h"
</c>

implementation class
GtkButton: GtkContainer

<doc> Create a new button, using {gtk_button_new}.  </doc>
instance (id)
  new
{
  pointer p;
<c>
  p = gtk_button_new ();
</c>
  = [[self alloc] init p];
}

<doc> Create a new button, using {gtk_button_new_with_label}.  </doc>
instance (id)
  new_with_label String label
{
  pointer p;
  int len;
<c>
  {
    char *s;
    C_STRING_WITH_TOM_STRING (s, len, label);
    p = gtk_button_new_with_label (s);
  }
</c>
  = [[self alloc] init p];
}

end;

implementation instance
GtkButton

<doc> Return the {gtkButton} for which this object stands.  </doc>
pointer
  gtkButton
{
  = object;
}

<doc> Pass on to {gtk_button_pressed}.  </doc>
void
  pressed
{
  pointer obj = object;

<c>
  gtk_button_pressed (obj);
</c>
}

<doc> Pass on to {gtk_button_released}.  </doc>
void
  released
{
  pointer obj = object;

<c>
  gtk_button_released (obj);
</c>
}

<doc> Pass on to {gtk_button_clicked}.  </doc>
void
  clicked
{
  pointer obj = object;

<c>
  gtk_button_clicked (obj);
</c>
}

<doc> Pass on to {gtk_button_enter}.  </doc>
void
  enter
{
  pointer obj = object;

<c>
  gtk_button_enter (obj);
</c>
}

<doc> Pass on to {gtk_button_leave}.  </doc>
void
  leave
{
  pointer obj = object;

<c>
  gtk_button_leave (obj);
</c>
}

end;
