<copyright> gtomk CList class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: CList.t,v 1.8 1999/02/15 21:57:29 tiggr Exp $</id>
    </copyright>

// But it compiles with 1.1.15, i.e., does not use or include the diff.
<gtk_version>1.0.0</gtk_version>

<c>
#include "glue.h"
</c>

implementation class
GtkCList: GtkContainer

///* constructers useful for gtk-- wrappers */
//void gtk_clist_construct (GtkCList * clist,
//			  gint columns,
//			  gchar * titles[]);
//
///* create a new GtkCList */

instance (id)
  new int columns
{
  pointer p;
<c>
  p = gtk_clist_new (columns);
</c>
  = [[self alloc] init p];
}

instance (id)
  new_with_titles Array titles
{
  int i, len, columns = [titles length];
  String title;
  pointer p;

<c>
  {
    char *s, **c_titles = alloca (columns * sizeof (*c_titles));
</c>

    for (i = 0; i < columns; i++)
      {
	title = titles[i];
<c>
	C_STRING_WITH_TOM_STRING (s, len, title);
	c_titles[i] = s; 
</c>
      }

<c>
    p = gtk_clist_new_with_titles (columns, c_titles);
  }
</c>
  = [[self alloc] init p];
}

end;

implementation instance
GtkCList

<doc> Return the {gtkCList} for which this object stands.  </doc>
pointer
  gtkCList
{
  = object;
}

void
  set_selection_mode int GTK_SELECTION_something
{
  pointer obj = object;
<c>
  gtk_clist_set_selection_mode (obj, GTK_SELECTION_something);
</c>
}

void
  freeze
{
  pointer obj = object;
<c>
  gtk_clist_freeze (obj);
</c>
}

void
  thaw
{
  pointer obj = object;
<c>
  gtk_clist_thaw (obj);
</c>
}

void
  column_titles_show
{
  pointer obj = object;
<c>
  gtk_clist_column_titles_show (obj);
</c>
}

void
  column_titles_hide
{
  pointer obj = object;
<c>
  gtk_clist_column_titles_hide (obj);
</c>
}

void
  column_title_active int column
{
  pointer obj = object;
<c>
  gtk_clist_column_title_active (obj, column);
</c>
}

void
  column_title_passive int column
{
  pointer obj = object;
<c>
  gtk_clist_column_title_passive (obj, column);
</c>
}

void
  column_titles_active
{
  pointer obj = object;
<c>
  gtk_clist_column_titles_active (obj);
</c>
}

void
  column_titles_passive
{
  pointer obj = object;
<c>
  gtk_clist_column_titles_passive (obj);
</c>
}

void
  set_column_title (int, String) (column, title)
{
  pointer obj = object;
  int len;
<c>
  {
    char *s;
    C_STRING_WITH_TOM_STRING (s, len, title);
    gtk_clist_set_column_title (obj, column, s);
  }
</c>
}

void
  set_column_widget (int, GtkWidget) (column, widget)
{
  pointer obj = object, widget_obj = [widget gtkWidget];
<c>
  gtk_clist_set_column_widget (obj, column, widget_obj);
</c>
}

void
  set_column_justification (int, int) (column, GTK_JUSTIFY_something)
{
  pointer obj = object;
<c>
  gtk_clist_set_column_justification (obj, column, GTK_JUSTIFY_something);
</c>
}

void
  set_column_width (int, int) (column, width)
{
  pointer obj = object;
<c>
  gtk_clist_set_column_width (obj, column, width);
</c>
}

void
  set_row_height int height
{
  pointer obj = object;
<c>
  gtk_clist_set_row_height (obj, height);
</c>
}

void
  moveto (int, int, float, float) (row, column, row_align, col_align)
{
  pointer obj = object;
<c>
  gtk_clist_moveto (obj, row, column, row_align, col_align);
</c>
}

int (GTK_VISIBILITY_something)
  row_is_visible int row
{
  pointer obj = object;
<c>
  GTK_VISIBILITY_something = gtk_clist_row_is_visible (obj, row);
</c>
}

int (GTK_CELL_something)
  get_cell_type (int, int) (row, column)
{
  pointer obj = object;
<c>
  GTK_CELL_something = gtk_clist_get_cell_type (obj, row, column);
</c>
}

void
  set_text (int, int, String) (row, column, text)
{
  pointer obj = object;
  int len;
<c>
  {
    char *s;
    C_STRING_WITH_TOM_STRING (s, len, text);
    gtk_clist_set_text (obj, row, column, s);
  }
</c>
}

<doc> Return the text in the indicated cell, or {nil} if the request is
    somehow invalid (i.e., {gtk_clist_get_text} returns 0).  </doc>
String (text)
  get_text (int, int) (row, column)
{
  pointer obj = object;
<c>
  {
    char *s;
    if (gtk_clist_get_text (obj, row, column, &s))
      text = (void *) byte_string_with_c_string (s);
  }
</c>
}

void
  set_pixmap (int, int, GdkPixmap, GdkBitmap) (row, column, pixmap, mask)
{
  pointer obj = object, pobj = [pixmap gdkPixmap], mobj;

  if (mask != nil)
    mobj = [mask gdkBitmap];
<c>
  gtk_clist_set_pixmap (obj, row, column, pobj, mobj);
</c>
}

(GdkPixmap, GdkBitmap) (pixmap, mask)
  get_pixmap (int, int) (row, column)
{
  pointer obj = object, pm, bm;
<c>
  {
    GdkPixmap *pmm;
    GdkBitmap *bmm;

    if (gtk_clist_get_pixmap (obj, row, column, &pmm, &bmm))
      {
	pm = pmm;
	bm = bmm;
      }
  }
</c>
  if (!!pm)
    pixmap = [GdkPixmap proxy pm create: YES];
  if (!!bm)
    mask = [GdkBitmap proxy bm create: YES];
}


void
  set_pixtext (int, int, String, int, GdkPixmap, GdkBitmap)
	      (row, column, text, spacing, pixmap, mask)
{
  pointer obj = object, pobj = [pixmap gdkPixmap], mobj;
  int len;

  if (mask != nil)
    mobj = [mask gdkBitmap];
<c>
  {
    char *s;
    C_STRING_WITH_TOM_STRING (s, len, text);
    gtk_clist_set_pixtext (obj, row, column, s, spacing, pobj, mobj);
  }
</c>
}

(String, int, GdkPixmap, GdkBitmap) (text, spacing, pixmap, mask)
  get_pixtext (int, int) (row, column)
{
  pointer obj = object, pm, bm;
<c>
  {
    GdkPixmap *pmm;
    GdkBitmap *bmm;
    guint8 sp;
    char *s;

    if (gtk_clist_get_pixtext (obj, row, column, &s, &sp, &pmm, &bmm))
      {
	pm = pmm;
	bm = bmm;
	text = (void *) byte_string_with_c_string (s);
	spacing = sp;
      }
  }
</c>
  if (!!pm)
    pixmap = [GdkPixmap proxy pm create: YES];
  if (!!bm)
    mask = [GdkBitmap proxy bm create: YES];
}

void
  set_foreground (int, GdkColor) (row, color)
{
  pointer obj = object, cobj = [color gdkColor];
<c>
  gtk_clist_set_foreground (obj, row, cobj);
</c>
}

void
  set_background (int, GdkColor) (row, color)
{
  pointer obj = object, cobj = [color gdkColor];
<c>
  gtk_clist_set_background (obj, row, cobj);
</c>
}

void
  set_shift (int, int, int, int) (row, column, vertical, horizontal)
{
  pointer obj = object;
<c>
  gtk_clist_set_shift (obj, row, column, vertical, horizontal);
</c>
}

int (new_row)
  append Indexed columns_text
{
  int i, len, n = [columns_text length];
  pointer obj = object;
  pointer text;

<c>
  text = g_malloc (n * sizeof (char *));
</c>

  for (i = 0; i < n; i++)
    {
      String col_text = columns_text[i];
<c>
      {
	char *s;
	C_STRING_WITH_TOM_STRING (s, len, col_text);
	((char **) text)[i] = s;
      }
</c>
    }
<c>
  new_row = gtk_clist_append (obj, text);
</c>
}

void
  insert (int, Indexed) (row, columns_text)
{
  int i, len, n = [columns_text length];
  pointer obj = object;
  pointer text;

<c>
  text = g_malloc (n * sizeof (char *));
</c>

  for (i = 0; i < n; i++)
    {
      String col_text = columns_text[i];
<c>
      {
	char *s;
	C_STRING_WITH_TOM_STRING (s, len, col_text);
	((char **) text)[i] = s;
      }
</c>
    }
<c>
  gtk_clist_insert (obj, row, text);
</c>
}

void
  remove int row
{
  pointer obj = object;
<c>
  gtk_clist_remove (obj, row);
</c>
}

void
  set_row_data (int, pointer) (row, data)
{
  pointer obj = object;
<c>
  gtk_clist_set_row_data (obj, row, data);
</c>
}

// This looses on systems where a `void *' is radically different from a
// `void (*) ()'...
// Fri Apr  3 14:11:43 1998, tiggr@gerbil.org
void
  set_row_data_full (int, pointer, pointer) (row, data, destroy_func)
{
  pointer obj = object;
<c>
  gtk_clist_set_row_data_full (obj, row, data, destroy_func);
</c>
}

pointer (data)
  get_row_data int row
{
  pointer obj = object;
<c>
  data = gtk_clist_get_row_data (obj, row);
</c>
}

int (row)
  find_row_from_data pointer data
{
  pointer obj = object;
<c>
  row = gtk_clist_find_row_from_data (obj, data);
</c>
}

void
  select_row (int, int) (row, column)
{
  pointer obj = object;
<c>
  gtk_clist_select_row (obj, row, column);
</c>
}

void
  unselect_row (int, int) (row, column)
{
  pointer obj = object;
<c>
  gtk_clist_unselect_row (obj, row, column);
</c>
}

void
  clear
{
  pointer obj = object;
<c>
  gtk_clist_clear (obj);
</c>
}

(int, int) (row, column)
  get_selection_info (int, int) (x, y)
{
  pointer obj = object;
<c>
  {
    gint r, c;
    if (gtk_clist_get_selection_info (obj, x, y, &r, &c))
      {
	row = r;
	column = c;
      }
  }
</c>
}

int (res)
  columns
{
  pointer obj = object;
<c>
  res = ((GtkCList *) obj)->columns;
</c>
}

GtkCListColumn 
  column int column
{
  = [[GtkCListColumn alloc] initCList self Column column];
}

end;

implementation class GtkCListColumn : State
end;

implementation instance GtkCListColumn
{
  <doc> associated GtkCList. </doc>
  GtkCList clist;
  <doc> referenced column number. </doc>
  int colno;
}

id
  initCList GtkCList cl
     Column int no
{
  clist = cl;
  colno = no;
  = self;
}

String (res)
  title
pre
  colno < [clist columns]
{
  pointer clist=[clist gtkCList];
  int no=colno;
  <c> res = (void *) byte_string_with_c_string \
            (((GtkCList *) clist)->column[no].title); </c>
}

int (res)
  width
pre
  colno < [clist columns]
{
  pointer clist=[clist gtkCList];
  int no=colno;
  <c> res = (((GtkCList *) clist)->column[no].width); </c>
}

int (res)
  justification
pre
  colno < [clist columns]
{
  pointer clist=[clist gtkCList];
  int no=colno;
  <c> res = (((GtkCList *) clist)->column[no].justification); </c>
}

GtkWidget (res)
  button
pre
  colno < [clist columns]
{
  pointer clist=[clist gtkCList];
  int no=colno;
  pointer gtkwidget;
  <c> gtkwidget = (((GtkCList *) clist)->column[no].button); </c>
  res = [GtkWidget proxy gtkwidget create: YES];
}

boolean (res)
  width_set
pre
  colno < [clist columns]
{
  pointer clist=[clist gtkCList];
  int no=colno;
  <c> res = (((GtkCList *) clist)->column[no].width_set); </c>
}

/*
  GdkRectangle area;
  GdkWindow *window;
*/

end;
