<copyright> gtomk MenuItem class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: MenuItem.t,v 1.7 1998/06/23 16:28:54 yacc Exp $</id>
    </copyright>

<gtk_version>1.0.0</gtk_version>

<c>
#include "glue.h"
</c>

implementation class
GtkMenuItem: GtkItem

instance (id)
  new
{
  pointer p;
<c>
  p = gtk_menu_item_new ();
</c>
  = [[self alloc] init p];
}

<doc> Create a new menu item, using {gtk_menu_item_new_with_label}.
    </doc>
instance (id)
  new_with_label String label
{
  pointer p;
  int len;
<c>
  {
    char *s;
    C_STRING_WITH_TOM_STRING (s, len, label);
    p = gtk_menu_item_new_with_label (s);
  }
</c>
  = [[self alloc] init p];
}

end;

implementation instance
GtkMenuItem

<doc> Return the {gtkMenuItem} for which this object stands.  </doc>
pointer
  gtkMenuItem
{
  = object;
}

void
  set_submenu GtkWidget submenu
{
  pointer obj = object, submenu_obj = [submenu gtkWidget];
<c>
  gtk_menu_item_set_submenu (obj, submenu_obj);
</c>
}
  
void
  remove_submenu
{
  pointer obj = object;
<c>
  gtk_menu_item_remove_submenu (obj);
</c>
}

//void       gtk_menu_item_set_placement    (GtkMenuItem         *menu_item,
//					   GtkSubmenuPlacement  placement);

void
  configure (boolean, boolean) (show_toggle_indicator, show_submenu_indicator)
{
  pointer obj = object;
<c>
  gtk_menu_item_configure (obj, show_toggle_indicator, show_submenu_indicator);
</c>
}

void
  select
{
  pointer obj = object;
<c>
  gtk_menu_item_select (obj);
</c>
}

void
  deselect
{
  pointer obj = object;
<c>
  gtk_menu_item_deselect (obj);
</c>
}

void
  activate
{
  pointer obj = object;
<c>
  gtk_menu_item_activate (obj);
</c>
}

void
  right_justify
{
  pointer obj = object;
<c>
  gtk_menu_item_right_justify (obj);
</c>
}

end;
