<copyright> gtomk Notebook class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: Notebook.t,v 1.4 1998/04/14 13:25:40 tiggr Exp $</id>
    </copyright>

<gtk_version>1.0.0</gtk_version>

<c>
#include "glue.h"
</c>

implementation class
GtkNotebook: GtkContainer

instance (id)
  new
{
  pointer p;
<c>
  p = gtk_notebook_new ();
</c>
  = [[self alloc] init p];
}

end;

implementation instance
GtkNotebook

<doc> Return the {gtkNotebook} for which this object stands.  </doc>
pointer
  gtkNotebook
{
  = object;
}

void
  append_page (GtkWidget, GtkWidget) (child, tab_label)
{
  pointer obj = object, child_obj = [child gtkWidget];
  pointer tab_label_obj = [tab_label gtkWidget];
<c>
  gtk_notebook_append_page (obj, child_obj, tab_label_obj);
</c>
}

void
  append_page_menu (GtkWidget, GtkWidget, GtkWidget)
		   (child, tab_label, menu_label)
{
  pointer obj = object, c = [child gtkWidget], tl = [tab_label gtkWidget];
  pointer ml = [menu_label gtkWidget];
<c>
  gtk_notebook_append_page_menu (obj, c, tl, ml);
</c>
}

void
  prepend_page (GtkWidget, GtkWidget) (child, tab_label)
{
  pointer obj = object, c = [child gtkWidget], tl = [tab_label gtkWidget];
<c>
  gtk_notebook_prepend_page (obj, c, tl);
</c>
}

void
  prepend_page_menu (GtkWidget, GtkWidget, GtkWidget)
		    (child, tab_label, menu_label)
{
  pointer obj = object, c = [child gtkWidget], tl = [tab_label gtkWidget];
  pointer ml = [menu_label gtkWidget];
<c>
  gtk_notebook_prepend_page_menu (obj, c, tl, ml);
</c>
}

void
  insert_page (GtkWidget, GtkWidget, int) (child, tab_label, position)
{
  pointer obj = object, c = [child gtkWidget], tl = [tab_label gtkWidget];
<c>
  gtk_notebook_insert_page (obj, c, tl, position);
</c>
}

void
  prepend_page_menu (GtkWidget, GtkWidget, GtkWidget, int)
		    (child, tab_label, menu_label, position)
{
  pointer obj = object, c = [child gtkWidget], tl = [tab_label gtkWidget];
  pointer ml = [menu_label gtkWidget];
<c>
  gtk_notebook_insert_page_menu (obj, c, tl, ml, position);
</c>
}

void
  remove_page int page_num
{
  pointer obj = object;
<c>
  gtk_notebook_remove_page (obj, page_num);
</c>
}

int (result)
  current_page
{
  pointer obj = object;
<c>
  result = gtk_notebook_current_page (obj);
</c>
}

void
  set_page int page_num
{
  pointer obj = object;
<c>
  gtk_notebook_set_page (obj, page_num);
</c>
}

void
  next_page
{
  pointer obj = object;
<c>
  gtk_notebook_next_page (obj);
</c>
}

void
  prev_page
{
  pointer obj = object;
<c>
  gtk_notebook_prev_page (obj);
</c>
}

void
  set_tab_pos int GTK_POS_something
{
  pointer obj = object;
<c>
  gtk_notebook_set_tab_pos (obj, GTK_POS_something);
</c>
}

void
  set_show_tabs boolean show_tabs
{
  pointer obj = object;
<c>
  gtk_notebook_set_show_tabs (obj, show_tabs);
</c>
}

void
  set_show_border boolean show_border
{
  pointer obj = object;
<c>
  gtk_notebook_set_show_border (obj, show_border);
</c>
}

void
  set_scrollable boolean scrollable
{
  pointer obj = object;
<c>
  gtk_notebook_set_scrollable (obj, scrollable);
</c>
}

void
  set_tab_border int border_width
{
  pointer obj = object;
<c>
  gtk_notebook_set_tab_border (obj, border_width);
</c>
}

void
  popup_enable
{
  pointer obj = object;
<c>
  gtk_notebook_popup_enable (obj);
</c>
}

void
  popup_disable
{
  pointer obj = object;
<c>
  gtk_notebook_popup_disable (obj);
</c>
}

end;
