<copyright> gtomk Text class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: Text.t,v 1.6 1998/07/21 15:57:16 yacc Exp $</id>
    </copyright>

<gtk_version>1.0.0</gtk_version>

<c>
#include "glue.h"
</c>

implementation class
GtkText: GtkEditable

instance (id)
  new (GtkAdjustment, GtkAdjustment) (hadjustment, vadjustment)
{
  pointer p, hobj, vobj;
  if (hadjustment)
    hobj = [hadjustment gtkAdjustment];
  if (vadjustment)
    vobj = [vadjustment gtkAdjustment];
<c>
  p = gtk_text_new (hobj, vobj);
</c>
  = [[self alloc] init p];
}

end;

implementation instance
GtkText

<doc> Return the {gtkText} for which this object stands.  </doc>
pointer
  gtkText
{
  = object;
}

GtkAdjustment
  vadj
{
  pointer obj = object;
  pointer cres;
  <c> cres = ((GtkText *) obj)->vadj; </c>
  = [GtkAdjustment proxy cres create: YES];
}

GtkAdjustment
  hadj
{
  pointer obj = object;
  pointer cres;
  <c> cres = ((GtkText *) obj)->hadj; </c>
  = [GtkAdjustment proxy cres create: YES];
}

void
  set_editable boolean editable
{
  pointer obj = object;
<c>
  gtk_text_set_editable (obj, editable);
</c>
}

void
  set_word_wrap boolean word_wrap
{
  pointer obj = object;
<c>
  gtk_text_set_word_wrap (obj, word_wrap);
</c>
}

void
  set_adjustments (GtkAdjustment, GtkAdjustment) (hadj, vadj)
{
  pointer obj = object, ho, vo;
  if (hadj != nil)
    ho = [hadj gtkAdjustment];
  if (vadj != nil)
    vo = [vadj gtkAdjustment];
<c>
  gtk_text_set_adjustments (obj, ho, vo);
</c>
}

void
  set_point int index
{
  pointer obj = object;
<c>
  gtk_text_set_point (obj, index);
</c>
}

int (point)
  get_point
{
  pointer obj = object;
<c>
  point = gtk_text_get_point (obj);
</c>
}

int (length)
  get_length
{
  pointer obj = object;
<c>
  length = gtk_text_get_length (obj);
</c>
}

void
  freeze
{
  pointer obj = object;
<c>
  gtk_text_freeze (obj);
</c>
}

void
  thaw
{
  pointer obj = object;
<c>
  gtk_text_thaw (obj);
</c>
}

void
  insert (GdkFont, GdkColor, GdkColor, String) (font, fore, back, chars)
{
  pointer obj = object, fo, fgo, bgo;
  int len;

  if (font != nil)
    fo = [font gdkFont];
  if (fore != nil)
    fgo = [fore gdkColor];
  if (back != nil)
    bgo = [back gdkColor];
<c>
  {
    char *s;
    C_STRING_WITH_TOM_STRING (s, len, chars);
    gtk_text_insert (obj, fo, fgo, bgo, s, len);
  }
</c>
}

boolean (succeeded)
  backward_delete int nchars
{
  pointer obj = object;
<c>
  succeeded = gtk_text_backward_delete (obj, nchars);
</c>
}

boolean (succeeded)
  forward_delete int nchars
{
  pointer obj = object;
<c>
  succeeded = gtk_text_forward_delete (obj, nchars);
</c>
}

byte (res)
  at int index
{
  pointer obj = object;
  <c> res = GTK_TEXT_INDEX ((GtkText *) obj, index); </c>
}

end;
