<copyright> gtomk ToolBar class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: ToolBar.t,v 1.4 1998/04/14 13:26:07 tiggr Exp $</id>
    </copyright>

<gtk_version>1.0.0</gtk_version>

<c>
#include "glue.h"
</c>

implementation class
GtkToolBar: GtkContainer

instance (id)
  new (int, int) (GTK_ORIENTATION_something, GTK_TOOLBAR_something)
{
  pointer p;
<c>
  p = gtk_toolbar_new (GTK_ORIENTATION_something, GTK_TOOLBAR_something);
</c>
  = [[self alloc] init p];
}

end;

implementation instance
GtkToolBar

<doc> Return the {gtkToolBar} for which this object stands.  </doc>
pointer
  gtkToolBar
{
  = object;
}

GtkWidget (widget)
  append_item (String, String, String, GtkWidget, pointer, pointer)
	      (text, tooltip_text, tooltip_private_text, icon,
	       callback, user_data)
{
  pointer p, obj = object, iobj = [icon gtkWidget];
  int len;
<c>
  {
    char *t, *tt, *tpt;
    C_STRING_WITH_TOM_STRING (t, len, text);
    C_STRING_WITH_TOM_STRING (tt, len, tooltip_text);
    C_STRING_WITH_TOM_STRING (tpt, len, tooltip_private_text);
    p = gtk_toolbar_append_item (obj, t, tt, tpt, iobj, callback, user_data);
  }
</c>
  if (!!p)
    widget = [GtkWidget proxy p];
}

GtkWidget (widget)
  prepend_item (String, String, String, GtkWidget, pointer, pointer)
	       (text, tooltip_text, tooltip_private_text, icon,
		callback, user_data)
{
  pointer p, obj = object, iobj = [icon gtkWidget];
  int len;
<c>
  {
    char *t, *tt, *tpt;
    C_STRING_WITH_TOM_STRING (t, len, text);
    C_STRING_WITH_TOM_STRING (tt, len, tooltip_text);
    C_STRING_WITH_TOM_STRING (tpt, len, tooltip_private_text);
    p = gtk_toolbar_prepend_item (obj, t, tt, tpt, iobj, callback, user_data);
  }
</c>
  if (!!p)
    widget = [GtkWidget proxy p];
}

GtkWidget (widget)
  prepend_item (String, String, String, GtkWidget, pointer, pointer, int)
	       (text, tooltip_text, tooltip_private_text, icon,
		callback, user_data, position)
{
  pointer p, obj = object, iobj = [icon gtkWidget];
  int len;
<c>
  {
    char *t, *tt, *tpt;
    C_STRING_WITH_TOM_STRING (t, len, text);
    C_STRING_WITH_TOM_STRING (tt, len, tooltip_text);
    C_STRING_WITH_TOM_STRING (tpt, len, tooltip_private_text);
    p = gtk_toolbar_insert_item (obj, t, tt, tpt, iobj, callback, user_data,
				 position);
  }
</c>
  if (!!p)
    widget = [GtkWidget proxy p];
}

void
  append_space
{
  pointer obj = object;
<c>
  gtk_toolbar_append_space (obj);
</c>
}

void
  prepend_space
{
  pointer obj = object;
<c>
  gtk_toolbar_prepend_space (obj);
</c>
}

void
  insert_space int position
{
  pointer obj = object;
<c>
  gtk_toolbar_insert_space (obj, position);
</c>
}

GtkWidget (widget)
  append_element (int, GtkWidget, String, String,
		  String, GtkWidget, pointer, pointer)
		 (GTK_TOOLBAR_CHILD_something, widget, text, tooltip_text,
		  tooltip_private_text, icon, callback, user_data)
{
  pointer p, obj = object, wobj = [widget gtkWidget], iobj = [icon gtkWidget];
  int len;
<c>
  {
    char *t, *tt, *tpt;
    C_STRING_WITH_TOM_STRING (t, len, text);
    C_STRING_WITH_TOM_STRING (tt, len, tooltip_text);
    C_STRING_WITH_TOM_STRING (tpt, len, tooltip_private_text);
    p = gtk_toolbar_append_element (obj, GTK_TOOLBAR_CHILD_something, wobj,
				    t, tt, tpt, iobj, callback, user_data);
  }
</c>
  if (!!p)
    widget = [GtkWidget proxy p];
}

GtkWidget (widget)
  prepend_element (int, GtkWidget, String, String, String, GtkWidget,
		   pointer, pointer)
		  (GTK_TOOLBAR_CHILD_something, widget, text, tooltip_text,
		   tooltip_private_text, icon, callback, user_data)
{
  pointer p, obj = object, wobj = [widget gtkWidget], iobj = [icon gtkWidget];
  int len;
<c>
  {
    char *t, *tt, *tpt;
    C_STRING_WITH_TOM_STRING (t, len, text);
    C_STRING_WITH_TOM_STRING (tt, len, tooltip_text);
    C_STRING_WITH_TOM_STRING (tpt, len, tooltip_private_text);
    gtk_toolbar_prepend_element (obj, GTK_TOOLBAR_CHILD_something, wobj,
				 t, tt, tpt, iobj, callback, user_data);
  }
</c>
  if (!!p)
    widget = [GtkWidget proxy p];
}

GtkWidget (widget)
  insert_element (int, GtkWidget, String, String, String, GtkWidget,
		  pointer, pointer, int)
		 (GTK_TOOLBAR_CHILD_something, widget, text, tooltip_text,
		  tooltip_private_text, icon, callback, user_data, position)
{
  pointer p, obj = object, wobj = [widget gtkWidget], iobj = [icon gtkWidget];
  int len;
<c>
  {
    char *t, *tt, *tpt;
    C_STRING_WITH_TOM_STRING (t, len, text);
    C_STRING_WITH_TOM_STRING (tt, len, tooltip_text);
    C_STRING_WITH_TOM_STRING (tpt, len, tooltip_private_text);
    gtk_toolbar_insert_element (obj, GTK_TOOLBAR_CHILD_something, wobj, t, tt,
				tpt, iobj, callback, user_data, position);
  }
</c>
  if (!!p)
    widget = [GtkWidget proxy p];
}

void
  append_widget (GtkWidget, String, String)
		(widget, tooltip_text, tooltip_private_text)
{
  pointer obj = object, wobj = [widget gtkWidget];
  int len;
<c>
  {
    char *tt, *tpt;
    C_STRING_WITH_TOM_STRING (tt, len, tooltip_text);
    C_STRING_WITH_TOM_STRING (tpt, len, tooltip_private_text);
    gtk_toolbar_append_widget (obj, wobj, tt, tpt);
  }
</c>
}

void
  prepend_widget (GtkWidget, String, String)
		 (widget, tooltip_text, tooltip_private_text)
{
  pointer obj = object, wobj = [widget gtkWidget];
  int len;
<c>
  {
    char *tt, *tpt;
    C_STRING_WITH_TOM_STRING (tt, len, tooltip_text);
    C_STRING_WITH_TOM_STRING (tpt, len, tooltip_private_text);
    gtk_toolbar_prepend_widget (obj, wobj, tt, tpt);
  }
</c>
}

void
  insert_widget (GtkWidget, String, String, int)
		(widget, tooltip_text, tooltip_private_text, position)
{
  pointer obj = object, wobj = [widget gtkWidget];
  int len;
<c>
  {
    char *tt, *tpt;
    C_STRING_WITH_TOM_STRING (tt, len, tooltip_text);
    C_STRING_WITH_TOM_STRING (tpt, len, tooltip_private_text);
    gtk_toolbar_insert_widget (obj, wobj, tt, tpt, position);
  }
</c>
}

void
  set_orientation int GTK_ORIENTATION_something
{
  pointer obj = object;
<c>
  gtk_toolbar_set_orientation (obj, GTK_ORIENTATION_something);
</c>
}

void
  gtk_toolbar_set_style int GTK_TOOLBAR_something
{
  pointer obj = object;
<c>
  gtk_toolbar_set_style (obj, GTK_TOOLBAR_something);
</c>
}

void
  set_space_size int space_size
{
  pointer obj = object;
<c>
  gtk_toolbar_set_space_size (obj, space_size);
</c>
}

void
  set_tooltips boolean enable
{
  pointer obj = object;
<c>
  gtk_toolbar_set_tooltips (obj, enable);
</c>
}

end;
