<copyright> gtomk Widget class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: Widget.t,v 1.15 1999/04/25 18:40:30 tiggr Exp $</id>
    </copyright>

// But it compiles with 1.1.15, i.e., does not use or include the diff.
<gtk_version>1.0.0</gtk_version>

<c>
#include "glue.h"
#include <stdlib.h>
</c>

implementation class
GtkWidget: GtkObject

void
  set_default_style GtkStyle style
{
  pointer sobj = [style gtkStyle];
<c>
  gtk_widget_set_default_style (sobj);
</c>
}

void
  set_default_colormap GdkColormap cmap
{
  pointer cobj = [cmap gdkColormap];
<c>
  gtk_widget_set_default_style (cobj);
</c>
}

void
  set_default_visual GdkVisual visual
{
  pointer vobj = [visual gdkVisual];
<c>
  gtk_widget_set_default_style (vobj);
</c>
}

GtkStyle (style)
  gtk_widget_get_default_style
{
  pointer p;
<c>
  p = gtk_widget_get_default_style ();
</c>
  if (!!p)
    style = [GtkStyle proxy p create: YES];
}

GdkColormap (colormap)
  gtk_widget_get_default_colormap
{
  pointer p;
<c>
  p = gtk_widget_get_default_colormap ();
</c>
  if (!!p)
    colormap = [GdkColormap proxy p create: YES];
}

GdkVisual (visual)
  gtk_widget_get_default_visual
{
  pointer p;
<c>
  p = gtk_widget_get_default_visual ();
</c>
  if (!!p)
    visual = [GdkVisual proxy p create: YES];
}

void
  push_style GtkStyle style
{
  pointer sobj = [style gtkStyle];
<c>
  gtk_widget_push_style (sobj);
</c>
}

void
  push_colormap GdkColormap cmap
{
  pointer cobj = [cmap gdkColormap];
<c>
  gtk_widget_push_style (cobj);
</c>
}

void
  push_visual GdkVisual visual
{
  pointer vobj = [visual gdkVisual];
<c>
  gtk_widget_push_style (vobj);
</c>
}

void
  pop_style
{
<c>
  gtk_widget_pop_style ();
</c>
}

void
  pop_colormap
{
<c>
  gtk_widget_pop_colormap ();
</c>
}

void
  pop_visual
{
<c>
  gtk_widget_pop_visual ();
</c>
}

end;

implementation instance
GtkWidget

<doc> Return the {gtkWidget} for which this object stands.  </doc>
pointer
  gtkWidget
{
  = object;
}

<doc> Invoke {gtk_widget_destroy}.  </doc>
void
  destroy
{
  pointer obj = object;
<c>
  gtk_widget_destroy (obj);
</c>
}

<doc> Pass on to {gtk_widget_unparent}.  </doc>
void
  unparent
{
  pointer obj = object;
<c>
  gtk_widget_unparent (obj);
</c>
}

<doc> Pass on to {gtk_widget_show}.  </doc>
void
  show
{
  pointer obj = object;
<c>
  gtk_widget_show (obj);
</c>
}

<doc> Pass on to {gtk_widget_show_now}.  </doc>
void
  show_now
{
  pointer obj = object;
<c>
  gtk_widget_show_now (obj);
</c>
}

<doc> Pass on to {gtk_widget_hide}.  </doc>
void
  hide
{
  pointer obj = object;
<c>
  gtk_widget_hide (obj);
</c>
}

<doc> Pass on to {gtk_widget_show_all}.  </doc>
void
  show_all
{
  pointer obj = object;
<c>
  gtk_widget_show_all (obj);
</c>
}

<doc> Pass on to {gtk_widget_hide_all}.  </doc>
void
  hide_all
{
  pointer obj = object;
<c>
  gtk_widget_hide_all (obj);
</c>
}

<doc> Pass on to {gtk_widget_map}.  </doc>
void
  map
{
  pointer obj = object;
<c>
  gtk_widget_map (obj);
</c>
}

<doc> Pass on to {gtk_widget_unmap}.  </doc>
void
  unmap
{
  pointer obj = object;
<c>
  gtk_widget_unmap (obj);
</c>
}

<doc> Pass on to {gtk_widget_realize}.  </doc>
void
  realize
{
  pointer obj = object;
<c>
  gtk_widget_realize (obj);
</c>
}

<doc> Pass on to {gtk_widget_unrealize}.  </doc>
void
  unrealize
{
  pointer obj = object;
<c>
  gtk_widget_unrealize (obj);
</c>
}

<doc> Pass on to {gtk_widget_queue_draw}.  </doc>
void
  queue_draw
{
  pointer obj = object;
<c>
  gtk_widget_queue_draw (obj);
</c>
}

<doc> Pass on to {gtk_widget_queue_resize}.  </doc>
void
  queue_resize
{
  pointer obj = object;
<c>
  gtk_widget_queue_resize (obj);
</c>
}

void
  draw (int, int, int, int) (x, y, w, h)
{
  pointer obj = object;
<c>
  {
    GdkRectangle rect = {x, y, w, h};

    gtk_widget_draw (obj, &rect);
  }
</c>
}

<doc> Pass on to {gtk_widget_draw_focus}.  </doc>
void
  draw_focus
{
  pointer obj = object;
<c>
  gtk_widget_draw_focus (obj);
</c>
}

<doc> Pass on to {gtk_widget_draw_default}.  </doc>
void
  draw_default
{
  pointer obj = object;
<c>
  gtk_widget_draw_default (obj);
</c>
}

(int, int) (w, h)
  size_request
{
  pointer obj = object;
<c>
  {
    GtkRequisition req = {};
    gtk_widget_size_request (obj, &req);
    w = req.width;
    h = req.height;
  }
</c>
}

void
  size_allocate (int, int, int, int) (x, y, width, height)
{
  pointer obj = object;
<c>
  {
    GtkAllocation a = {x, y, width, height};
    gtk_widget_size_allocate (obj, &a);
  }
</c>
}

void
  add_accelerator (String, pointer, int, int, int)
                  (signal_name, group, key, modifiers, flags)
{
  pointer obj = object;
  int len;
<c>
  {
    char *s;
    C_STRING_WITH_TOM_STRING (s, len, signal_name);
    gtk_widget_add_accelerator (obj, s, group, key, modifiers, flags);
  }
</c>
}

void
  remove_accelerator (pointer, int, int)
		     (table, accel_key, accel_mods)
{
  pointer obj = object;
  int len;
<c>
  {
    gtk_widget_remove_accelerator (obj, table, accel_key, accel_mods);
  }
</c>
}
void
  event pointer event
{
  pointer obj = object;
<c>
  gtk_widget_event (obj, event);
</c>
}

void
  activate
{
  pointer obj = object;

<c>
  gtk_widget_activate (obj);
</c>
}

void
  reparent GtkWidget new_parent
{
  pointer obj = object, new_parent_obj = [new_parent gtkWidget];
<c>
  gtk_widget_reparent (obj, new_parent_obj);
</c>
}

void
  popup (int, int) (x, y)
{
  pointer obj = object;
<c>
  gtk_widget_popup (obj, x, y);
</c>
}

(int, int, int, int, int) (result, x, y, w, h)
  intersect (int, int, int, int) (ax, ay, aw, ah)
{
  pointer obj = object;
<c>
  {
    GdkRectangle intersection, area = {ax, ay, aw, ah};
    result = gtk_widget_intersect (obj, &area, &intersection);
    x = intersection.x;
    y = intersection.y;
    w = intersection.width;
    h = intersection.height;
  }
</c>
}

void
  grab_focus
{
  pointer obj = object;

<c>
  gtk_widget_grab_focus (obj);
</c>
}

void
  grab_default
{
  pointer obj = object;

<c>
  gtk_widget_grab_default (obj);
</c>
}

void
  set_name String name
{
  pointer obj = object;
  int len;
<c>
  {
    char *s;
    C_STRING_WITH_TOM_STRING (s, len, name);
    gtk_widget_set_name (obj, s);
  }
</c>
}

String (name)
  get_name
{
  pointer obj = object;
<c>
  {
    char *s = gtk_widget_get_name (obj);
    name = (void *) byte_string_with_c_string (s);
  }
</c>
}

void
  set_state int GTK_STATE_something
{
  pointer obj = object;
<c>
  gtk_widget_set_state (obj, GTK_STATE_something);
</c>
}

void
  set_sensitive int sensitive
{
  pointer obj = object;
<c>
  gtk_widget_set_sensitive (obj, sensitive);
</c>
}

void
  set_parent GtkWidget parent
{
  pointer obj = object, parent_obj = [parent gtkWidget];
<c>
  gtk_widget_set_parent (obj, parent_obj);
</c>
}

void
  set_parent_window GdkWindow parent_window
{
  pointer obj = object, parent_window_obj = [parent_window gdkWindow];
<c>
  gtk_widget_set_parent_window (obj, parent_window_obj);
</c>
}

GdkWindow (result)
  get_parent_window
{
  pointer obj = object;
  pointer w;

<c>
  w = gtk_widget_get_parent_window (obj);
</c>

  = [GdkWindow proxy w create: YES];
}

void
  set_uposition (int, int) (x, y)
{
  pointer obj = object;
<c>
  gtk_widget_set_uposition (obj, x, y);
</c>
}

void
  set_usize (int, int) (width, height)
{
  pointer obj = object;
<c>
  gtk_widget_set_usize (obj, width, height);
</c>
}

void
  set_events int GDK_MASK_events
{
  pointer obj = object;
<c>
  gtk_widget_set_events (obj, GDK_MASK_events);
</c>
}

void
  set_extension_events int GDK_EXTENSION_EVENTS_something
{
  pointer obj = object;
<c>
  gtk_widget_set_extension_events (obj, GDK_EXTENSION_EVENTS_something);
</c>
}

int (GDK_EXTENSION_EVENTS_something)
  get_extension_events
{
  pointer obj = object;
<c>
  GDK_EXTENSION_EVENTS_something = gtk_widget_get_extension_events (obj);
</c>
}

GtkWidget (toplevel)
  get_toplevel
{
  pointer p, obj = object;
<c>
  p = gtk_widget_get_toplevel (obj);
</c>
  if (!!p)
    toplevel = [GtkWidget proxy p];
}

GtkWidget (ancestor)
  get_ancestor int widget_type
{
  pointer p, obj = object;
<c>
  p = gtk_widget_get_ancestor (obj, widget_type);
</c>
  if (!!p)
    ancestor = [GtkWidget proxy p];
}

GdkColormap (cmap)
  gtk_widget_get_colormap
{
  pointer p, obj = object;
<c>
  p = gtk_widget_get_colormap (obj);
</c>
  if (!!p)
    cmap = [GdkColormap proxy p create: YES];
}

GdkVisual (visual)
  gtk_widget_get_visual
{
  pointer p, obj = object;
<c>
  p = gtk_widget_get_visual (obj);
</c>
  if (!!p)
    visual = [GdkVisual proxy p create: YES];
}

int (result)
  get_events
{
  pointer obj = object;

<c>
  result = gtk_widget_get_events (obj);
</c>
}

(int, int) (x, y)
  get_pointer
{
  pointer obj = object;
<c>
  gtk_widget_get_pointer (obj, &x, &y);
</c>
}

boolean (result)
  is_ancestor GtkWidget ancestor
{
  pointer obj = object, ancestor_obj = [ancestor gtkWidget];
<c>
  result = gtk_widget_is_ancestor (obj, ancestor_obj);
</c>
}

int (result)
  hide_on_delete
{
  pointer obj = object;

<c>
  result = gtk_widget_hide_on_delete (obj);
</c>
}

void
  set_style GtkStyle style
{
  pointer obj = object, style_obj = [style gtkStyle];
<c>
  gtk_widget_set_style (obj, style_obj);
</c>
}

void
  set_rc_style
{
  pointer obj = object;

<c>
  gtk_widget_set_rc_style (obj);
</c>
}

void
  ensure_style
{
  pointer obj = object;

<c>
  gtk_widget_ensure_style (obj);
</c>
}

GtkStyle (style)
  gtk_widget_get_style
{
  pointer p, obj = object;
<c>
  p = gtk_widget_get_style (obj);
</c>
  if (!!p)
    style = [GtkStyle proxy p create: YES];
}

void
  restore_default_style
{
  pointer obj = object;

<c>
  gtk_widget_restore_default_style (obj);
</c>
}

void
  shape_combine_mask (GdkBitmap, int, int) (shape_mask, offset_x, offset_y)
{
  pointer obj = object, smobj = [shape_mask gdkBitmap];
<c>
  gtk_widget_shape_combine_mask (obj, smobj, offset_x, offset_y);
</c>
}

<comment>
// 
// /* These two functions enable drag and/or drop on a widget,
//  *  and also let Gtk know what data types will be accepted (use MIME
//  *  type naming, plus tacking "URL:" on the front for link dragging)
//  */
// void	     gtk_widget_dnd_drag_set (GtkWidget	    *widget,
// 				      guint8	     drag_enable,
// 				      gchar	   **type_accept_list,
// 				      guint	     numtypes);
// void	     gtk_widget_dnd_drop_set (GtkWidget	    *widget,
// 				      guint8	     drop_enable,
// 				      gchar	   **type_accept_list,
// 				      guint	     numtypes,
// 				      guint8	     is_destructive_operation);
// 
// /* Used to reply to a DRAG_REQUEST event - if you don't want to 
//  * give the data then pass in NULL for it 
//  */
// void	     gtk_widget_dnd_data_set (GtkWidget	    *widget,
// 				      GdkEvent	    *event,
// 				      gpointer	     data,
// 				      gulong	     data_numbytes);
</comment>

/******************** access macro's ********************/

GdkWindow (result)
  window
{
  pointer obj = object;
  pointer gdkwindow_obj;

<c>
  gdkwindow_obj = GTK_WIDGET (obj)->window;
</c>

  = [GdkWindow proxy gdkwindow_obj create: YES];
}

(int, int) (width, height)
  allocationSize
{
  pointer obj = object;
<c>
  width = GTK_WIDGET (obj)->allocation.width;
  height = GTK_WIDGET (obj)->allocation.height;
</c>
}

byte (state)
  state
{
  pointer obj = object;
<c>
  state = GTK_WIDGET_STATE (obj);
</c>
}

GtkStyle
  style
{
  pointer obj = object;
  pointer style;
<c>
  style = GTK_WIDGET (obj)->style;
</c>
  = [GtkStyle proxy style create: YES];
}

end;

<doc> {GtkSelection} mirrors the fields in TOM, as the pointer of the
      C struct is of undefined life time. </doc>

implementation class 
GtkSelectionData : State

end;

implementation instance
GtkSelectionData
{
  public GdkAtom selection;
  public GdkAtom target;
  public GdkAtom type;
  public int format;
  public pointer data;
  public int length;
}

id
  init pointer gsdptr
{
  int atom;
  <c> atom = ((GtkSelectionData *) gsdptr)->selection; </c>
  selection = [[GdkAtom alloc] init atom];
  <c> atom = ((GtkSelectionData *) gsdptr)->target; </c>
  target = [[GdkAtom alloc] init atom];
  <c> atom = ((GtkSelectionData *) gsdptr)->type; </c>
  type = [[GdkAtom alloc] init atom];
  <c> atom = ((GtkSelectionData *) gsdptr)->format; </c>
  format = atom;
  <c> atom = ((GtkSelectionData *) gsdptr)->length; </c>
  length = atom;
  if (length > 0) {
    pointer temp;
    <c> 
      temp = malloc (atom); 
      memcpy (temp, ((GtkSelectionData *) gsdptr)->data, atom);
    </c>
    data = temp;
  }
  = self;
}

void
  dealloc
{
  pointer temp = data;
  <c> if (temp) free (temp); </c>
}

String (res)
  stringValue
{
  GdkAtom STRING = [GdkAtom new "STRING"];
  if ([STRING equal type] && (length >= 0)) {
    pointer cdata = data;
    int clen = length;
    <c> res = (void *) byte_string_with_string (cdata, clen); </c>
  }
}

end;


