<copyright> gtomk gtomk class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of GTOMK.  GTOMK is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: gtomk.t,v 1.7 1998/04/23 20:58:30 yacc Exp $</id>
    </copyright>

<c>
#include "glue.h"
</c>

implementation class Runtime extension Access

String
  long_program_name
{
  = long_program_name;
}

end;

implementation instance Runtime extension Access
end;

implementation class
gtomk: State

<doc> Do a {gtk_init} with the {arguments}.  </doc>
void
  init MutableArray arguments
{
  String lpn = [Runtime long_program_name];
  int len;

  // Pass the arguments, and reconstruct them back.
  // Tue Mar 31 16:34:36 1998, tiggr@gerbil.org
<c>
   {
     char **argv = alloca (2 * sizeof *argv);
     int argc = 1; 

     C_STRING_WITH_TOM_STRING (argv[0], len, lpn);
     argv[1] = 0;

     gtk_init (&argc, &argv);
   }
</c>
}

int (res)
  major_version
{
  <c> res=gtk_major_version; </c>
}

int (res)
  minor_version
{
  <c> res=gtk_minor_version; </c>
}

int (res)
  micro_version
{
  <c> res=gtk_micro_version; </c>
}

///* Initialization, exit, mainloop and miscellaneous routines
// */
//void	   gtk_init		 (int	       *argc,
//				  char	     ***argv);

<doc> Invoke {gtk_exit}, after having told the {Runtime} that we
    {willExit}.  </doc>
void
  exit int error_code
{
  [Runtime willExit error_code];
<c>
  gtk_exit (error_code);
</c>
}

//gchar*	   gtk_set_locale	 (void);
//gint	   gtk_events_pending	 (void);

<doc> Do {gtk_main}.  </doc>
void
  main
{
<c>
  gtk_main ();
</c>
}

int (level)
  main_level
{
<c>
  level = gtk_main_level ();
</c>
}

<doc> Do {gtk_main_quit}.  </doc>
void
  main_quit
{
<c>
  gtk_main_quit ();
</c>
}

//gint	   gtk_main_iteration	 (void);
///* gtk_main_iteration() calls gtk_main_iteration_do(TRUE) */
//gint	   gtk_main_iteration_do (gboolean blocking);
//
//gint	   gtk_true		   (void);
//gint	   gtk_false		   (void);
//
void 
  grab_add GtkWidget widget
{
  pointer wptr=[widget gtkWidget];
  <c> gtk_grab_add((GtkWidget *) wptr); </c> 
}

void 
  grab_remove GtkWidget widget
{
  pointer wptr=[widget gtkWidget];
  <c> gtk_grab_remove((GtkWidget *) wptr); </c> 
}

GtkWidget
  grab_get_current
{
  pointer widget;
  <c> widget = gtk_grab_get_current(); </c>
  = [GtkWidget proxy widget create: YES];
}

//void	   gtk_init_add		   (GtkFunction	       function,
//				    gpointer	       data);
//void	   gtk_quit_add_destroy	   (guint	       main_level,
//				    GtkObject	      *object);
//guint	   gtk_quit_add		   (guint	       main_level,
//				    GtkFunction	       function,
//				    gpointer	       data);
//guint	   gtk_quit_add_full	   (guint	       main_level,
//				    GtkFunction	       function,
//				    GtkCallbackMarshal marshal,
//				    gpointer	       data,
//				    GtkDestroyNotify   destroy);
//void	   gtk_quit_remove	   (guint	       quit_handler_id);
//void	   gtk_quit_remove_by_data (gpointer	       data);
//guint	   gtk_timeout_add_full	   (guint32	       interval,
//				    GtkFunction	       function,
//				    GtkCallbackMarshal marshal,
//				    gpointer	       data,
//				    GtkDestroyNotify   destroy);
//guint	   gtk_timeout_add	   (guint32	       interval,
//				    GtkFunction	       function,
//				    gpointer	       data);
//guint	   gtk_timeout_add_interp  (guint32	       interval,
//				    GtkCallbackMarshal function,
//				    gpointer	       data,
//				    GtkDestroyNotify   notify);
//void	   gtk_timeout_remove	   (guint	       timeout_handler_id);
//

<doc> TOM equivalent of {gtk_idle_add}.  </doc>
void
  idle_add All object
     using selector sel
{
  // This should probably employ some mechanism like the gtomk_signal_relay.
  // Is this what marshalling is for?
  // Fri Apr  3 00:49:57 1998, tiggr@gerbil.org
<c>
  {
    gtomk_glue *cb = g_new (__typeof__ (*cb), 1);
    cb->rcv = (void *) object;
    cb->sel = sel;

    gtk_idle_add_full (GTK_PRIORITY_DEFAULT, (void *) gtomk_idle_fire, NULL,
		       cb, gtomk_free);
		       
  }
</c>
}

//guint	   gtk_idle_add_priority   (gint	       priority,
//				    GtkFunction	       function,
//				    gpointer	       data);
//guint	   gtk_idle_add_full	   (gint	       priority,
//				    GtkFunction	       function,
//				    GtkCallbackMarshal marshal,
//				    gpointer	       data,
//				    GtkDestroyNotify   destroy);
//guint	   gtk_idle_add_interp	   (GtkCallbackMarshal marshal,
//				    gpointer	       data,
//				    GtkDestroyNotify   destroy);
//void	   gtk_idle_remove	   (guint	       idle_handler_id);
//void	   gtk_idle_remove_by_data (gpointer	       data);
//guint	   gtk_input_add_full	   (gint	       source,
//				    GdkInputCondition  condition,
//				    GdkInputFunction   function,
//				    GtkCallbackMarshal marshal,
//				    gpointer	       data,
//				    GtkDestroyNotify   destroy);
//void	   gtk_input_remove	   (guint	       input_handler_id);
//
//
//guint	   gtk_key_snooper_install (GtkKeySnoopFunc snooper,
//				    gpointer	    func_data);
//void	   gtk_key_snooper_remove  (guint	    snooper_handler_id);
//  
//GdkEvent*  gtk_get_current_event   (void);
//GtkWidget* gtk_get_event_widget	 (GdkEvent	*event);

end;

implementation instance
gtomk

end;
