<copyright> tomgnome Canvas class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter Schoenmakers</a>

    Copyright &copy; 1999 Pieter J. Schoenmakers

    This file is part of tomgnome.  tomgnome is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the tomgtk distribution; see the file COPYING.LIB.

    <id>$Id: Canvas.t,v 1.4 1999/04/30 20:46:20 tiggr Exp $</id>
    </copyright>

<gnome_version>1.0.8</gnome_version>

<c>
#include "glue.h"
</c>

/******************** GnomeCanvas ********************/

implementation class
GnomeCanvas: GtkLayout

<doc> Creates a new canvas.  You should check that the canvas is created
    with the proper visual and colormap if you want to insert imlib images
    into it.  You can do this by doing
    gtk_widget_push_visual(gdk_imlib_get_visual()) and
    gtk_widget_push_colormap(gdk_imlib_get_colormap()) before calling
    gnome_canvas_new().  After calling it, you should do
    gtk_widget_pop_visual() and gtk_widget_pop_colormap().

    You should call gnome_canvas_set_scroll_region() soon after calling
    this function to set the desired scrolling limits for the canvas.
    </doc>
instance (id)
  new
{
  pointer p;

<c>
  p = gnome_canvas_new ();
</c>

  = [[self alloc] init p];
}

<doc> Create a new antialiased empty canvas.  You want to push the GdkRgb
    colormap and visual for this.  Return value: the newly-created canvas.
    </doc>
instance (id)
  new_aa
{
  pointer p;

<c>
  p = gnome_canvas_new_aa ();
</c>

  = [[self alloc] init p];
}

end;

implementation instance
GnomeCanvas

<doc> Return the {GnomeCanvas} for which this object stands.  </doc>
pointer
  gnomeCanvas
{
  = object;
}

<doc> Returns the root canvas item group of the canvas.  </doc>
GnomeCanvasGroup
  root
{
  pointer p, o = object;

  <c>
    p = gnome_canvas_root (o);
  </c>

  = [GnomeCanvasGroup proxy p create: YES];
}

/********** object arguments **********/

/********** flags **********/

boolean (v)
  need_repick
{
  pointer p = object;
  <c>
    {
      GnomeCanvas *c = p;
      v = c->need_repick;
    }
  </c>
}

void
  set_need_repick
{
  pointer p = object;
  <c>
    {
      GnomeCanvas *c = p;
      c->need_repick = 1;
    }
  </c>
}

/********** miscellanea **********/

<doc> For use only by item type implementations.  Request that the canvas
    eventually redraw the specified region.  The region contains (x1, y1)
    but not (x2, y2).  </doc>
void
  request_redraw (double, double, double, double) (x1, y1, x2, y2)
{
  pointer p = object;

  <c>
    gnome_canvas_request_redraw (p, x1, y1, x2, y2);
  </c>
}

<doc> Sets the limits of the scrolling region.  </doc>
void
  set_scroll_region (double, double, double, double) (x1, y1, x2, y2)
{
  pointer o = object;

  <c>
    gnome_canvas_set_scroll_region (o, x1, y1, x2, y2);
  </c>
}

end;
