<copyright> tomgnome Dialog class.
    Written by <a href="mailto:yacc@gerbil.org">Andreas Kostyrka</a>

    Copyright &copy; 1998 Andreas Kostyrka

    This file is part of tomgnome.  tomgnome is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the tomgtk distribution; see the file COPYING.LIB.

    <id>$Id: Dialog.t,v 1.1 1998/06/09 09:42:39 yacc Exp $</id>
    </copyright>

<gtk_version>1.1.0</gtk_version>

<c>
#include <libgnomeui/gnome-dialog.h>
#include <tom/util.h>
</c>

implementation class
GnomeDialog: GtkWindow

end;

implementation instance
GnomeDialog

<doc> Return the {GnomeDialog} for which this object stands.  </doc>
pointer
  gnomeDialog
{
  = object;
}

GtkWidget 
  vbox
{
  pointer obj = object;
  pointer wid;
  <c> wid = ((GnomeDialog *) obj)->vbox; </c>
  = [GtkWidget proxy wid create: YES];
}

<comment> How to deal with the ...?
          Andreas Kostyrka <yacc@gerbil.org> Mon Jun  8 17:12:48 MEST 1998

GtkWidget* gnome_dialog_new            (const gchar * title,
					...);

/* Connect to the "clicked" signal of a single button */
void       gnome_dialog_button_connect (GnomeDialog *dialog,
					gint button,
					GtkSignalFunc callback,
					gpointer data);

/* Make the dialog modal */
void       gnome_dialog_set_modal      (GnomeDialog *dialog);

/* Run the dialog, return the button # that was pressed or -1 if none.
 */
gint       gnome_dialog_run_modal      (GnomeDialog *dialog);
/* Like run_modal, but does not call set_modal before run */
gint       gnome_dialog_run	       (GnomeDialog *dialog);

/* Set the default button. - it will have a little highlight, 
   and pressing return will activate it. */
void       gnome_dialog_set_default    (GnomeDialog *dialog,
					gint         button);
/* Set sensitivity of a button */
void       gnome_dialog_set_sensitive  (GnomeDialog *dialog,
					gint         button,
					gboolean     setting);

/* Set the accelerator for a button. Note that there are two
   default accelerators: "Return" will be the same as clicking
   the default button, and "Escape" will emit delete_event. 
   (Note: neither of these is in the accelerator table,
   Return is a Gtk default and Escape comes from a key press event
   handler.) */
void       gnome_dialog_set_accelerator(GnomeDialog * dialog,
					gint button,
					const guchar accelerator_key,
					guint8       accelerator_mods);

/* Hide and optionally destroy. Destroys by default, use close_hides() 
   to change this. */
void       gnome_dialog_close (GnomeDialog * dialog);

/* Make _close just hide, not destroy. */
void       gnome_dialog_close_hides (GnomeDialog * dialog, 
				     gboolean just_hide);

/* Whether to close after emitting clicked signal - default is
   FALSE. If clicking *any* button should close the dialog, set it to
   TRUE.  */
void       gnome_dialog_set_close      (GnomeDialog * dialog,
					gboolean click_closes);

/* Normally an editable widget will grab "Return" and keep it from 
   activating the dialog's default button. This connects the activate
   signal of the editable to the default button. */
void       gnome_dialog_editable_enters   (GnomeDialog * dialog,
					   GtkEditable * editable);

/* *** Deprecated. Is a set_close wrapper now. */
void       gnome_dialog_set_destroy (GnomeDialog * d, gboolean self_destruct);


/* Use of append_buttons is discouraged, it's really
   meant for subclasses. */
void       gnome_dialog_append_buttons (GnomeDialog * dialog,
					const gchar * first,
					...);
</comment>
end;
