<copyright> tomgnome FontPicker class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter Schoenmakers</a>

    Copyright &copy; 1999 Pieter Schoenmakers

    This file is part of tomgnome.  tomgnome is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the tomgtk distribution; see the file COPYING.LIB.

    <id>$Id: FontPicker.t,v 1.1 1999/04/30 20:46:26 tiggr Exp $</id>
    </copyright>

<c>
#include <libgnomeui/gnome-font-picker.h>
#include <tom/util.h>
</c>

implementation class
GnomeFontPicker: GtkButton

<doc> Designated allocator.  </doc>
instance (id)
  new
{
  pointer p;

  <c>
    p = gnome_font_picker_new ();
  </c>

  = [self proxy p create: YES];
}

end;

implementation instance
GnomeFontPicker

void
  set_title String title
{
  pointer p = object;
  
  <c>
    {
      int len;
      char *s;

      C_STRING_WITH_TOM_STRING (s, len, title);
      gnome_font_picker_set_title (p, s);
    }
  </c>
}

int (GnomeFontPickerMode_something)
  get_mode
{
  pointer p = object;
  
  <c>
    GnomeFontPickerMode_something = gnome_font_picker_get_mode (p);
  </c>
}

void
  set_mode int GnomeFontPickerMode_something
{
  pointer p = object;
  
  <c>
    gnome_font_picker_set_mode (p, GnomeFontPickerMode_something);
  </c>
}

void
  fi_set_use_font_in_label boolean yes_p
		     size: int size = 12
{
  pointer p = object;
  
  <c>
    gnome_font_picker_fi_set_use_font_in_label (p, yes_p, size);
  </c>
}

void
  fi_set_show_size boolean yes_p
{
  pointer p = object;
  
  <c>
    gnome_font_picker_fi_set_show_size (p, yes_p);
  </c>
}

//void       gnome_font_picker_uw_set_widget    (GnomeFontPicker *gfp,
//                                               GtkWidget       *widget);

String (result)
  get_font_name
{
  pointer p = object;
  
  <c>
    result = (void *) byte_string_with_c_string
					(gnome_font_picker_get_font_name (p));
  </c>
}

GdkFont (result)
  get_font
{
  pointer o, p = object;
  
  <c>
    o = gnome_font_picker_get_font (p);
  </c>

  = [GdkFont proxy o create: YES];
}

boolean
  set_font_name String name
{
  pointer p = object;
  
  <c>
    {
      int len;
      char *s;

      C_STRING_WITH_TOM_STRING (s, len, name);
      gnome_font_picker_set_font_name (p, s);
    }
  </c>
}

String (result)
  get_preview_text
{
  pointer p = object;
  
  <c>
    result = (void *) byte_string_with_c_string
				       (gnome_font_picker_get_preview_text (p));
  </c>
}

void
  set_preview_text String text
{
  pointer p = object;
  
  <c>
    {
      int len;
      char *s;

      C_STRING_WITH_TOM_STRING (s, len, text);
      gnome_font_picker_set_preview_text (p, s);
    }
  </c>
}

end;
