<copyright> tomgnome Gnome class.
    Written by <a href="mailto:yacc@gerbil.org">Andreas Kostyrka</a>

    Copyright &copy; 1998 Andreas Kostyrka.

    This file is part of tomgnome.  tomgnome is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the GTOMK distribution; see the file COPYING.LIB.

    <id>$Id: Gnome.t,v 1.9 1999/04/30 20:46:27 tiggr Exp $</id>
    </copyright>

<gnome_version>0.99.8</gnome_version>

<c>
#include <libgnome/libgnome.h>
#include <libgnomeui/libgnomeui.h>
#include <libgnomeui/gnome-ice.h>
#include <tom/util.h>
</c>

implementation class
Gnome: instance (All)

<doc> Do a {gnome_init} with the given arguments.  </doc>
void
    init String program_name
    args Array arguments
  flags: int flags = 0
{
  String lpn = [Runtime long_program_name];
  int i, len, alen = [arguments length];
  String onearg;

  <c>
    {
      char **argv = alloca ((alen+1) * sizeof *argv);
      char *cshortname;

      C_STRING_WITH_TOM_STRING (argv[0], len, lpn);
      argv[1] = 0;
      C_STRING_WITH_TOM_STRING (cshortname, len, program_name);
      for(i=1;i<alen;i++)
	{
	  </c>
	    onearg = arguments[i];
	  <c>
	  C_STRING_WITH_TOM_STRING (argv[i], len, onearg);
	}

      gnome_init (cshortname, 0, alen + 1, argv);
    }
  </c>
}

<doc> Do a gnome_ice_init. Should be called before any ICE functions
      are used. </doc>

void
  ice_init
{
  <c> gnome_ice_init(); </c>
}

<doc>
   This method is used by configurator programs that set some global
   X server state.  The general idea is that such a program can be run
   in an `initialization' mode, where it sets the server state
   according to some saved state.  This function implements a mutex
   for such programs.  The mutex a property on the root window.  Call
   this function with the session manager's session id.  If it returns
   false, then do nothing.  If it returns true, then the caller has
   obtained the mutex and should proceed with initialization.  The
   property name is generally of the form GNOME_<PROGRAM>_PROPERTY. 
</doc>

boolean (res)
  startup_acquire_token (String, String) (property_name, sm_id)
{
  <c> {
    int len;
    char *cpropname;
    char *csmid;
    
    C_STRING_WITH_TOM_STRING (cpropname, len, property_name);
    C_STRING_WITH_TOM_STRING (csmid, len, sm_id);
    res = gnome_startup_acquire_token (cpropname, csmid);
  } </c>
}


String (res)
  unix_error_string int errnum
{
  <c> {
    const char *cres;
    
    cres = g_unix_error_string (errnum);
    res = (void *) byte_string_with_c_string ((char *) cres);
  } </c>
}

String (res)
  libdir_file String filename
{
  int len;
  <c> {
    char *cres;

    C_STRING_WITH_TOM_STRING (cres, len, filename);
    cres = gnome_libdir_file (cres);
    if (cres)
      res = (void *) byte_string_with_c_string (cres);
    g_free (cres);
  } </c>
}

String (res)
  datadir_file String filename
{
  int len;
  <c> {
    char *cres;

    C_STRING_WITH_TOM_STRING (cres, len, filename);
    cres = gnome_datadir_file (cres);
    if (cres)
      res = (void *) byte_string_with_c_string (cres);
    g_free (cres);
  } </c>
}

String (res)
  pixmap_file String filename
{
  int len;
  <c> {
    char *cres;

    C_STRING_WITH_TOM_STRING (cres, len, filename);
    cres = gnome_pixmap_file (cres);
    if (cres)
      res = (void *) byte_string_with_c_string (cres);
    g_free (cres);
  } </c>
}

String (res)
  user_shell
{
  int len;
  <c> {
    char *cres;

    cres = gnome_util_user_shell();
    res = (void *) byte_string_with_c_string (cres);
    g_free (cres);
  } </c>
}


end;

implementation instance
Gnome: instance (All)
end;
