<copyright> tomgnome MDI class and helpers.
    Written by <a href="mailto:yacc@gerbil.org">Andreas Kostyrka</a>

    Copyright &copy; 1998 Andreas Kostyrka

    This file is part of tomgnome.  tomgnome is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the tomgtk distribution; see the file COPYING.LIB.

    <id>$Id: MDI.t,v 1.9 1999/04/30 20:46:32 tiggr Exp $</id>
    </copyright>

<gnome_version>0.99.8</gnome_version>
<gtk_version>1.1.0</gtk_version>

<c>
#include <libgnome/libgnome.h>
#include <libgnomeui/libgnomeui.h>
#include <tom/util.h>
</c>

implementation class
GnomeMDI : GtkObject

instance (id)
  new (String, String) (appname, title)
{
  pointer cmdi;
  <c> {
    int len;
    char *capp, *ctitle;
    

    C_STRING_WITH_TOM_STRING (capp, len, appname);
    C_STRING_WITH_TOM_STRING (ctitle, len, title);
    
    cmdi = gnome_mdi_new (capp, ctitle);
  } </c>
  = [[self alloc] init cmdi];
}

end;

implementation instance
GnomeMDI

<doc> Return the {GnomeMDI} for which this object stands.  </doc>
pointer
  gnomeMDI
{
  = object;
}

void
  set_mode int mode
{
  pointer obj = object;
  <c> gnome_mdi_set_mode ((GnomeMDI *) obj, mode); </c>
}

void
  set_menu_template GnomeUIArray menu
{
  pointer obj = object;
  pointer cmenu = [menu gnomeUIInfo];
  <c> gnome_mdi_set_menubar_template ((GnomeMDI *) obj, cmenu); </c>
}

void
  set_toolbar_template GnomeUIArray menu
{
  pointer obj = object;
  pointer cmenu = [menu gnomeUIInfo];
  <c> gnome_mdi_set_toolbar_template ((GnomeMDI *) obj, cmenu); </c>
}

void
  set_child_menu_path String path
{
  pointer obj = object;
  <c> {
    int len;
    char *cpath;

    C_STRING_WITH_TOM_STRING (cpath, len, path);
    gnome_mdi_set_child_menu_path ((GnomeMDI *) obj, cpath);
  } </c>
}

void
  set_child_list_path String path
{
  pointer obj = object;
  <c> {
    int len;
    char *cpath;

    C_STRING_WITH_TOM_STRING (cpath, len, path);
    gnome_mdi_set_child_list_path ((GnomeMDI *) obj, cpath);
  } </c>
}

GnomeMDIChild
  active_child
{
  pointer obj = object;
  pointer res;
  <c>
    res = gnome_mdi_get_active_child ((GnomeMDI *) obj);
  </c>
  if (res)
    = [GnomeMDIChild proxy res create: YES]; 
}

GtkWidget
  active_view
{
  pointer obj = object;
  pointer res;
  <c> res = ((GnomeMDI *) obj)->active_view; </c>
  if (res)
    = [GtkWidget proxy res create: YES]; 
}

GnomeApp
  active_window
{
  pointer obj = object;
  pointer res;
  <c> res = ((GnomeMDI *) obj)->active_window; </c>
  if (res)						   
    = [GnomeApp proxy res create: YES]; 
}

int (res)
  add_view GnomeMDIChild mc
{
  pointer obj = object;
  pointer cmc = [mc gnomeMDIChild];
  <c> res = gnome_mdi_add_view ((GnomeMDI *) obj, (GnomeMDIChild *) cmc); </c>
}

int (res)
  remove_view (GtkWidget, boolean) (widget, nr)
{
  pointer obj = object;
  pointer cwidget = [widget gtkWidget];
  <c> res = gnome_mdi_remove_view ((GnomeMDI *) obj, cwidget, nr); </c>
}

int (res)
  add_child GnomeMDIChild mc
{
  pointer obj = object;
  pointer cmc = [mc gnomeMDIChild];
  <c> res = gnome_mdi_add_child ((GnomeMDI *) obj, (GnomeMDIChild *) cmc); </c>
}

int (res)
  remove_child (GnomeMDIChild, boolean) (mc, nr)
{
  pointer obj = object;
  pointer cmc = [mc gnomeMDIChild];
  <c> res = gnome_mdi_remove_child ((GnomeMDI *) obj, cmc, nr); </c>
}

int (res)
  remove_all int nr
{
  pointer obj = object;
  <c> res = gnome_mdi_remove_all ((GnomeMDI *) obj, nr); </c>
}

end;

implementation class
GnomeMDIChild: GtkObject

instance (id)
  new
{
  [self unimplemented cmd];
//  pointer cmdichild;
//  <c> cmdichild = gnome_mdi_child_new(); </c>
//  = [[self alloc] init cmdichild];
}

end;

implementation instance
GnomeMDIChild

<doc> Return the {GnomeMDIChild} for which this object stands.  </doc>
pointer
  gnomeMDIChild
{
  = object;
}

ObjectArray
  views
{
  pointer obj = object;
  pointer cres;
  <c> cres = ((GnomeMDIChild *) obj)->views; </c>
  = [[[GList alloc] init cres withWrapper [GtkWidget self]]
      asObjectArray];
}

GtkWidget
  add_view
{
  pointer obj = object;
  pointer res; 
  <c> res = gnome_mdi_child_add_view ((GnomeMDIChild *) obj); </c>
  = [GtkWidget proxy res create: YES];
}

void
  remove_view GtkWidget view
{
  pointer obj = object;
  pointer cview = [view gtkWidget];
  <c> gnome_mdi_child_remove_view ((GnomeMDIChild *) obj, (GtkWidget *) cview); </c>
}

void
  set_name String name
{
  pointer obj = object;
  <c> {
    int len;
    char *cname;

    C_STRING_WITH_TOM_STRING (cname, len, name);
    gnome_mdi_child_set_name ((GnomeMDIChild *) obj, cname);
  } </c>
}

void
  set_menu_template GnomeUIArray menu
{
  pointer obj = object;
  pointer cmenu = [menu gnomeUIInfo];
  <c> gnome_mdi_child_set_menu_template ((GnomeMDIChild *) obj, (GnomeUIInfo *) cmenu); </c>
}

end;

<doc> This extension covers the special stuff about a GtkWidget that happens to be a 
      view of a GnomeMDIChild. Don't kick, kick the GnomeMDI author. </doc>

implementation class
GtkWidget extension GnomeMDIdesignflaws

end;

implementation instance
GtkWidget extension GnomeMDIdesignflaws

GnomeMDIChild
  gnome_mdi_view_get_child
{
  pointer obj = object;
  pointer cres;
  <c> cres = gnome_mdi_get_child_from_view (obj); </c>
  = [GnomeMDIChild proxy cres create: YES];
}

GnomeApp
  gnome_mdi_view_get_window
{
  pointer obj = object;
  pointer cres;
  <c> cres = gnome_mdi_get_app_from_view (obj); </c>
  = [GnomeApp proxy cres create: YES];

}

end;
