<copyright> tomgnome Pixmap class.
    Written by <a href="mailto:yacc@gerbil.org">Andreas Kostyrka</a>

    Copyright &copy; 1998 Andreas Kostyrka

    This file is part of tomgnome.  tomgnome is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the tomgtk distribution; see the file COPYING.LIB.

    <id>$Id: Pixmap.t,v 1.3 1999/04/30 20:46:33 tiggr Exp $</id>
    </copyright>

<gtk_version>1.1.0</gtk_version>

<c>
#include <libgnome/libgnome.h>
#include <libgnomeui/libgnomeui.h>
#include <tom/util.h>
</c>

implementation class
GnomePixmap: GtkWidget

instance (id) (res)
  new_from_file String filename
{
  pointer cpixmap;
  <c> {
    int len;
    char *cfilename;

    C_STRING_WITH_TOM_STRING (cfilename, len, filename);
    cpixmap = gnome_pixmap_new_from_file (cfilename);
  } </c>
  = [[self alloc] init cpixmap];
}

instance (id) (res)
  new_from_file String filename
        at_size (int, int) (width, height)
{
  pointer cpixmap;
  <c> {
    int len;
    char *cfilename;

    C_STRING_WITH_TOM_STRING (cfilename, len, filename);
    cpixmap = gnome_pixmap_new_from_file_at_size (cfilename, width, height);
  } </c>
  = [[self alloc] init cpixmap];
}

end;

implementation instance
GnomePixmap

<doc> Return the {GnomePixmap} for which this object stands.  </doc>
pointer
  gnomePixmap
{
  = object;
}

void
  load_file String filename
{
  pointer obj = object;
  <c> {
    int len;
    char *cfilename;

    C_STRING_WITH_TOM_STRING (cfilename, len, filename);
    gnome_pixmap_load_file ((GnomePixmap *) obj, cfilename);
  } </c>
}

void
  load_file String filename
        at_size (int, int) (width, height)
{
  pointer obj = object;
  <c> {
    int len;
    char *cfilename;

    C_STRING_WITH_TOM_STRING (cfilename, len, filename);
    gnome_pixmap_load_file_at_size ((GnomePixmap *) obj, cfilename, width, height);
  } </c>
}

end;

<comment>
GtkWidget *gnome_pixmap_new_from_xpm_d         (char **xpm_data);
GtkWidget *gnome_pixmap_new_from_xpm_d_at_size (char **xpm_data, int width, int height);
GtkWidget *gnome_pixmap_new_from_rgb_d         (unsigned char *data, unsigned char *alpha,
						int rgb_width, int rgb_height);
GtkWidget *gnome_pixmap_new_from_rgb_d_shaped  (unsigned char *data, unsigned char *alpha,
						int rgb_width, int rgb_height,
						GdkImlibColor *shape_color);
GtkWidget *gnome_pixmap_new_from_rgb_d_at_size (unsigned char *data, unsigned char *alpha,
						int rgb_width, int rgb_height,
						int width, int height);
GtkWidget *gnome_pixmap_new_from_gnome_pixmap  (GnomePixmap *gpixmap);

void       gnome_pixmap_load_xpm_d             (GnomePixmap *gpixmap, char **xpm_data);
void       gnome_pixmap_load_xpm_d_at_size     (GnomePixmap *gpixmap, char **xpm_data, int width, int height);
void       gnome_pixmap_load_rgb_d             (GnomePixmap *gpixmap, unsigned char *data, unsigned char *alpha,
						int rgb_width, int rgb_height);
void       gnome_pixmap_load_rgb_d_shaped      (GnomePixmap *gpixmap, unsigned char *data, unsigned char *alpha,
						int rgb_width, int rgb_height,
						GdkImlibColor *shape_color);
void       gnome_pixmap_load_rgb_d_at_size     (GnomePixmap *gpixmap, unsigned char *data, unsigned char *alpha,
						int rgb_width, int rgb_height,
						int width, int height);

</comment>

