<copyright> tomgnome GnomeUIInfo classes.
    Written by <a href="mailto:yacc@gerbil.org">Andreas Kostyrka</a>

    Copyright &copy; 1998 Andreas Kostyrka

    This file is part of tomgnome.  tomgnome is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the tomgtk distribution; see the file COPYING.LIB.

    <id>$Id: UIInfo.t,v 1.2 1999/02/17 23:32:55 tiggr Exp $</id>
    </copyright>

<gtk_version>1.1.0</gtk_version>

<c>
#include <libgnome/libgnome.h>
#include <libgnomeui/libgnomeui.h>
#include <stdio.h>
#include <tom/util.h>
#include <stdlib.h>
#include <assert.h>

static void widget_connect (GtkWidget *widget, gpointer invocation);

</c>

implementation class 
GnomeUIArray : State
{
  const ALLOCCHUNKS = 16;
}

extern instance (id)
  with dynamic args;

end;

implementation instance
GnomeUIArray
{
  pointer cvalue;
  pointer ovalue;
  int length;
  int allocated;
  boolean owner;
}

id
  init
{
  = self;
  owner = TRUE;
}

void
  add GnomeUIInfo i
{
  if ((length + 1) > allocated)
    [self resize (allocated + ALLOCCHUNKS)];

  pointer cval = cvalue;
  pointer oval = ovalue;
  int len = length;

  <c> {
    DECL_SEL (v_putInto_p);
    
    GnomeUIInfo *cplace = ((GnomeUIInfo *)cval) + len;
    tom_object *oplace = ((tom_object *)oval) + len;
    *oplace = (void *)i;
    TRT_SEND ((void_imp), i, SEL(v_putInto_p), cplace);
  } </c>
  length++;
}

void
  resize int size
{
  if (size>length) {
    pointer cval = cvalue;
    pointer oval = ovalue;
    int len = length;
    int alen = allocated;
    pointer ncval;
    pointer noval;

    <c> {
      ncval = g_new (GnomeUIInfo, size);
      noval = g_new (tom_object, size);
      assert (ncval);
      assert (noval);		/* This is broken. But better an assert abort
				   then a random core dump. 
				   yacc@gerbil.org 
				   Thu Jul 08 19:08:49 CEST 1998 */
      memcpy (ncval, cval, len * sizeof(GnomeUIInfo));
      memcpy (noval, oval, len * sizeof(tom_object));
      if (cval)
	g_free (cval);
      if (oval)
	g_free (oval);
    } </c>
    ovalue = noval;
    cvalue = ncval;
    allocated = size;
  }
}

pointer (res)
  gnomeUIInfo
{
  pointer cval = cvalue, oval = ovalue;
  int len = length;
  
  <c> {
    int i;
    GnomeUIInfo *uivalue = cval;
    for (i = 0; i < len; i++) {
      if ((uivalue[i].type == GNOME_APP_UI_SUBTREE) || 
	  (uivalue[i].type == GNOME_APP_UI_RADIOITEMS)) {
	DECL_SEL(p_gnomeUIInfo);
	uivalue[i].moreinfo = TRT_SEND ((pointer_imp),
					((tom_object *)oval)[i],
					SEL(p_gnomeUIInfo));
      }
    }
    if (len<=0)
      assert ("GnomeUIInfoArray length 0" == NULL);
    if (uivalue[len - 1].type!=GNOME_APP_UI_ENDOFINFO)
      assert ("GnomeUIInfoArray: no ENDOFINFO" == NULL);
  } </c>
  = cvalue;
}

void
  dealloc
{
  if (owner) {
    pointer cval = cvalue;
    int len = length;
    <c> {
      GnomeUIInfo *val = cval;
      int i;
      for (i=0; i<len; i++) {
	if (val[i].label)
	  g_free (val[i].label);
	if (val[i].hint)
	  g_free (val[i].hint);
	if (val[i].pixmap_info)
	  g_free (val[i].pixmap_info);
      }
      g_free (val);
      cval = NULL;
    } </c>
  cvalue = cval;
  }
  [super dealloc];
}

extern void
  gc_mark_elements;
end;

implementation class
GnomeUIInfo : State

end;

implementation instance
GnomeUIInfo

void
  putInto pointer place
{
}

end;

implementation class
GnomeUIInfoSubtree : GnomeUIInfo

instance (id)
      new String label
  subtree GnomeUIArray subtree
{
  = [[self alloc] init label subtree subtree];
}

end;

implementation instance
GnomeUIInfoSubtree
{
  String label;
  GnomeUIArray subtree;
}

id
     init String l
  subtree GnomeUIArray st
{
  label = l;
  subtree = st;
  = self;
}

pointer
  gnomeUIInfo
{
  = [subtree gnomeUIInfo];
}

void
  putInto pointer place
{
  [super putInto place];
  String l = label;
  pointer csubtree;
  <c> {
    GnomeUIInfo *p = place;
    p->type = GNOME_APP_UI_SUBTREE;
    p->label = c_string_with_tom_string ((void *)l);
    p->hint = NULL;
    p->moreinfo = csubtree;
    p->user_data = NULL;
    p->unused_data = NULL;
    p->pixmap_type = GNOME_APP_PIXMAP_NONE;
    p->pixmap_info = NULL;
    p->accelerator_key = 0;
    p->ac_mods = 0;
    p->widget = NULL;
  } </c>
}

end;

implementation class
GnomeUIInfoRadioList : GnomeUIInfo

instance (id)
      new GnomeUIArray subtree
{
  = [[self alloc] init subtree];
}

end;

implementation instance
GnomeUIInfoRadioList
{
  GnomeUIArray radiolist;
}

id
     init GnomeUIArray st
{
  radiolist = st;
  = self;
}

pointer
  gnomeUIInfo
{
  = [radiolist gnomeUIInfo];
}

void
  putInto pointer place
{
  [super putInto place];
  pointer csubtree;
  <c> {
    GnomeUIInfo *p = place;
    p->type = GNOME_APP_UI_RADIOITEMS;
    p->label = NULL;
    p->hint = NULL;
    p->moreinfo = csubtree;
    p->user_data = NULL;
    p->unused_data = NULL;
    p->pixmap_type = GNOME_APP_PIXMAP_NONE;
    p->pixmap_info = NULL;
    p->accelerator_key = 0;
    p->ac_mods = 0;
    p->widget = NULL;
  } </c>
}

end;

implementation class
GnomeUIInfoEnd : GnomeUIInfo

instance (id)
  new
{
  = [[self alloc] init];
}

end;

implementation instance
GnomeUIInfoEnd

void
  putInto pointer place
{
  [super putInto place];
  <c> {
    GnomeUIInfo *p = place;
    p->type = GNOME_APP_UI_ENDOFINFO;
    p->label = NULL;
    p->hint = NULL;
    p->moreinfo = NULL;
    p->user_data = NULL;
    p->unused_data = NULL;
    p->pixmap_type = GNOME_APP_PIXMAP_NONE;
    p->pixmap_info = NULL;
    p->accelerator_key = 0;
    p->ac_mods = 0;
    p->widget = NULL;
  } </c>
}

end;

implementation class
GnomeUIInfoSeparator : GnomeUIInfo

instance (id)
  new
{
  = [[self alloc] init];
}

end;

implementation instance
GnomeUIInfoSeparator

void
  putInto pointer place
{
  [super putInto place];
  <c> {
    GnomeUIInfo *p = place;
    p->type = GNOME_APP_UI_SEPARATOR;
    p->label = NULL;
    p->hint = NULL;
    p->moreinfo = NULL;
    p->user_data = NULL;
    p->unused_data = NULL;
    p->pixmap_type = GNOME_APP_PIXMAP_NONE;
    p->pixmap_info = NULL;
    p->accelerator_key = 0;
    p->ac_mods = 0;
    p->widget = NULL;
  } </c>
}

end;

implementation class
GnomeUIInfoEndOfInfo : GnomeUIInfo

instance (id)
  new
{
  = [[self alloc] init];
}

end;

implementation instance
GnomeUIInfoEndOfInfo

void
  putInto pointer place
{
  [super putInto place];
  <c> {
    GnomeUIInfo *p = place;
    p->type = GNOME_APP_UI_ENDOFINFO;
    p->label = NULL;
    p->hint = NULL;
    p->moreinfo = NULL;
    p->user_data = NULL;
    p->unused_data = NULL;
    p->pixmap_type = GNOME_APP_PIXMAP_NONE;
    p->pixmap_info = NULL;
    p->accelerator_key = 0;
    p->ac_mods = 0;
    p->widget = NULL;
  } </c>
}

end;

implementation class
GnomeUIInfoItem : GnomeUIInfo

instance (id)
     new String label
      to Invocation invoke
    tip: String tip = ""
    xpm: String xpm = nil
  stock: String stock = nil
pre
  !((xpm != nil) && (stock != nil))
{
  = [[self alloc] init label to invoke tip tip xpm xpm stock stock];
}

end;

implementation instance
GnomeUIInfoItem
{
  String label;
  String tip;
  String xpm;
  String stock;
  Invocation invoke;
}

id
   init String l
     to Invocation i
    tip String t
    xpm String x
  stock String s
{
  label = l;
  tip = t;
  xpm = x;
  invoke = i;
  stock = s;
  = self;
}

void
  putInto pointer place
{
  [super putInto place];
  String l = label;
  String t = tip;
  String x = xpm;
  String s = stock;
  Invocation i = invoke;
  <c> {
    GnomeUIInfo *p = place;
    p->type = GNOME_APP_UI_ITEM;
    if (l)
      p->label = c_string_with_tom_string ((void *)l);
    else
      p->label = NULL;
    if (t)
      p->hint = c_string_with_tom_string ((void *)t);
    else
      p->hint = NULL;
    p->moreinfo = &widget_connect;
    p->user_data = i;
    p->unused_data = NULL;
    if (x) {
      p->pixmap_type = GNOME_APP_PIXMAP_FILENAME;
      p->pixmap_info = c_string_with_tom_string ((void *)x);
    } else if (s) {
      p->pixmap_type = GNOME_APP_PIXMAP_STOCK;
      p->pixmap_info = c_string_with_tom_string ((void *)s);
    } else {
      p->pixmap_type = GNOME_APP_PIXMAP_NONE;
      p->pixmap_info = NULL;
    }
    p->accelerator_key = 0;
    p->ac_mods = 0;
    p->widget = NULL;
  } </c>
}

end;

implementation class
GnomeUIInfoToggleItem : GnomeUIInfo

instance (id)
     new String label
      to Invocation invoke
    tip: String tip = ""
    xpm: String xpm = nil
  stock: String stock = nil
pre
  !((xpm != nil) && (stock != nil))
{
  = [[self alloc] init label to invoke tip tip xpm xpm stock stock];
}

end;

implementation instance
GnomeUIInfoToggleItem
{
  String label;
  String tip;
  String xpm;
  String stock;
  Invocation invoke;
}

id
   init String l
     to Invocation i
    tip String t
    xpm String x
  stock String s
{
  label = l;
  tip = t;
  xpm = x;
  invoke = i;
  stock = s;
  = self;
}

void
  putInto pointer place
{
  [super putInto place];
  String l = label;
  String t = tip;
  String x = xpm;
  String s = stock;
  Invocation i = invoke;
  <c> {
    GnomeUIInfo *p = place;
    p->type = GNOME_APP_UI_TOGGLEITEM;
    p->label = c_string_with_tom_string ((void *)l);
    p->hint = c_string_with_tom_string ((void *)t);
    p->moreinfo = i;
    p->user_data = NULL;
    p->unused_data = NULL;
    if (x) {
      p->pixmap_type = GNOME_APP_PIXMAP_FILENAME;
      p->pixmap_info = c_string_with_tom_string ((void *)x);
    } else if (s) {
      p->pixmap_type = GNOME_APP_PIXMAP_STOCK;
      p->pixmap_info = c_string_with_tom_string ((void *)s);
    } else {
      p->pixmap_type = GNOME_APP_PIXMAP_NONE;
      p->pixmap_info = NULL;
    }
    p->accelerator_key = 0;
    p->ac_mods = 0;
    p->widget = NULL;
  } </c>
}

end;

implementation class
GnomeUIInfoRadioItem : GnomeUIInfo

instance (id)
     new String label
      to Invocation invoke
    tip: String tip = ""
    xpm: String xpm = nil
  stock: String stock = nil
pre
  !((xpm != nil) && (stock != nil))
{
  = [[self alloc] init label to invoke tip tip xpm xpm stock stock];
}

end;

implementation instance
GnomeUIInfoRadioItem
{
  String label;
  String tip;
  String xpm;
  String stock;
  Invocation invoke;
}

id
   init String l
     to Invocation i
    tip String t
    xpm String x
  stock String s
{
  label = l;
  tip = t;
  xpm = x;
  invoke = i;
  stock = s;
  = self;
}

void
  putInto pointer place
{
  [super putInto place];
  String l = label;
  String t = tip;
  String x = xpm;
  String s = stock;
  Invocation i = invoke;
  <c> {
    GnomeUIInfo *p = place;
    p->type = GNOME_APP_UI_RADIOITEMS;
    p->label = c_string_with_tom_string ((void *)l);
    p->hint = c_string_with_tom_string ((void *)t);
    p->moreinfo = i;
    p->user_data = NULL;
    p->unused_data = NULL;
    if (x) {
      p->pixmap_type = GNOME_APP_PIXMAP_FILENAME;
      p->pixmap_info = c_string_with_tom_string ((void *)x);
    } else if (s) {
      p->pixmap_type = GNOME_APP_PIXMAP_STOCK;
      p->pixmap_info = c_string_with_tom_string ((void *)s);
    } else {
      p->pixmap_type = GNOME_APP_PIXMAP_NONE;
      p->pixmap_info = NULL;
    }
    p->accelerator_key = 0;
    p->ac_mods = 0;
    p->widget = NULL;
  } </c>
}

end;


<c>

static void widget_connect (GtkWidget *widget, gpointer invocation) {
  DECL_USEL (tom,v_fire);
  TRT_SEND ((void_imp), invocation, USEL (tom, v_fire));
}

</c>

